SystemOrganization addCategory: #'GT-Spotter-EventRecorder-Analysis'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Builders'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Core'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Support'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Tests'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Traits'!

Trait named: #TGTABookmarkIt
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 10:30'!
bookmarkIt
	self explicitRequirement! !

!TGTABookmarkIt methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:47'!
bookmarks
	self explicitRequirement! !

!TGTABookmarkIt methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:27'!
gtInspectorActionBookmarkIt
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self bookmarkIt ];
		icon: Smalltalk ui icons glamorousBookmark;
		title: 'Bookmark It'! !

!TGTABookmarkIt methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/19/2015 10:46'!
gtInspectorBookmarksIn: composite
	<gtInspectorPresentationOrder: -1>
	composite tabulator 
		when: [ self isBookmarked ];
		title: 'Bookmarks';
		with: [ :browser | 
			browser
				row: #table;
				row: #description.
			browser transmit 
				to: #table;
				andShow: [ :c |
					c table 
						display: [ :anEventCollection | anEventCollection relatedBookmarks ];
						column: 'Garbage'
							evaluated: [ :each | each garbageString ]
							width: 57;
						column: 'Description'
							evaluated:  [ :each | GTObjectPrinter new asTruncatedTextFrom: 
															each description asString ];
						updateOn: GTACollectionAnnouncement 
							from: [ :aEventCollection | 
										aEventCollection bookmarks announcer ];
						selectionAct: [ :list :bookmark | 
								self toggleGarbage: list rawSelection.
								list update ]
							entitled: 'Toggle garbage';
						selectionAct: [ :list :relatedBookmarks |
								self removeBookmark: list selection.
								list update ]
							entitled: 'Remove bookmark' ].
			browser transmit
				to: #description;
				from: #table port: #selection;
				andShow: [ :c |
					c rubricText
						display: #description;
						act: [ :port :bookmark | 
								bookmark description: port text asString.
								self bookmarks save.
								port pane browser panes do: #update ] 
							on: $s
							entitled: 'Save' ]
		] ! !

!TGTABookmarkIt methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:49'!
isBookmarked
	^ self bookmarks hasRelatedTo: self! !

!TGTABookmarkIt methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:48'!
relatedBookmarks
	^ self bookmarks relatedTo: self! !

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 13:06'!
removeBookmark: aBookmark
	self bookmarks 
		removeBookmark: aBookmark;
		save.! !

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 10:49'!
toggleGarbage: aGTABookmark 
	aGTABookmark toggleGarbage.
	self bookmarks save.! !

Trait named: #TGTSpotterCategoryView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterCategoryView methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:58'!
categoryLabelOccurrences
	| col |
	col := OrderedCollection new.
	self categoryLabels asBag 
		doWithOccurrences: [ :obj :occurrences | 
			col add: obj -> occurrences ].
	^ col! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/26/2015 11:31'!
categoryView
	| b ds points |
	b := RTGrapher new.
	points := self sessionsPerCategoryLabel sortedAs: [ :x :y | x size > y size ].
	points ifEmpty: [ ^ b view ].
	b extent: ((points size * 30) min: 800) @ 150.
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj categoryLabel asString, ', ', obj size asString, ' times' ].
	ds points: points.
	ds barShape 
			color: (Color green alpha: 0.3); 
			width: 10.
	ds histogramWithBarTitle: #categoryLabel.
	ds y: [ :obj | obj size ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:30'!
gtInspectorCategoryViewIn: composite
	<gtInspectorPresentationOrder: -2>
	composite roassal2
		title: 'Category';
		initializeView: [ self categoryView ]
		! !

Trait named: #TGTSpotterDurationView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:09'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 10:56'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

Trait named: #TGTSpotterSessionsTable
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterSessionsTable methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 11:03'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :anEvent | anEvent sessions ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each withPreviewSymbol ]
			width: 57;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 50! !

Trait named: #TGTSpotterUpdateEvents
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterUpdateEvents methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/9/2015 10:54'!
gtInspectorActionRefreshEvents
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self updateEvents ];
		icon: Smalltalk ui icons glamorousRefresh;
		title: 'Update events'! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:37'!
analysisIcon
	^ GTSpotterEventIcons showPreviewIcon! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Show Preview'! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:55'!
isForTimelineView
	^ true! !

!GTSpotterRecorderOpenEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Open Spotter'! !

RTHorizontalLineLayout subclass: #GTAHorizontalDivingLineLayout
	instanceVariableNames: 'diveInLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 16:35'!
diveElement: eachElement
	^ (self diveInLevel cull: eachElement cull: self)
 			* self diveStep! !

!GTAHorizontalDivingLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/14/2015 12:33'!
diveElements: elements
	elements do: [ :eachElement | eachElement translateBy: 0 @ (self diveElement: eachElement) ]! !

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 16:37'!
diveInLevel
	^ diveInLevel ifNil: [ diveInLevel := self newDiveInLevel ]! !

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/17/2015 11:48'!
diveStep
	^ 5! !

!GTAHorizontalDivingLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/17/2015 10:11'!
doExecute: elements
	super doExecute: elements.
	self diveElements: elements! !

!GTAHorizontalDivingLineLayout methodsFor: 'initialize-release' stamp: 'JurajKubelka 4/17/2015 14:53'!
initialize
	super initialize.
	horizontalGap := 2.
	self alignCenter.! !

!GTAHorizontalDivingLineLayout methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 16:38'!
newDiveInLevel
	^ [ :element | #diveInLevel cull: element model ]! !

GTAHorizontalDivingLineLayout subclass: #GTAHorizontalRealTimelineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAHorizontalRealTimelineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/17/2015 15:54'!
doExecute: elements
	| offset previousElement right left min minTime maxTime duration max |
	min := elements detectMin: [ :each | each position x ].
	elements do: [ :each | each translateTo: (min position x) @ (each position y) ].
	minTime := (elements detectMin: [ :each | each model dateAndTimeWithFixedTimeZone ]) model dateAndTimeWithFixedTimeZone.
	maxTime := (elements detectMax: [ :each | each model dateAndTimeWithFixedTimeZone ]) model dateAndTimeWithFixedTimeZone.
	duration := maxTime  - minTime.
	duration = 0 seconds
		ifTrue: [ max := 500 ]
		ifFalse: [ max := duration seconds * 8 ].
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: max.
	self diveElements: elements.
	previousElement := elements first.
	offset := 0.
	elements allButFirstDo: [ :element |
		right := previousElement encompassingRectangle right.
		left := element encompassingRectangle left.
		right > left
			ifTrue: [ offset := (right - left) rounded + 3 ]
			"ifFalse: [ offset := 0 ]".
		element translateBy: (offset @ 0).
		previousElement := element.
	 ].! !

!GTAHorizontalRealTimelineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 12:34'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:15'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:34'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTSpotterEventIcons diveInCategoryIcon ]
			ifTrue: [ GTSpotterEventIcons diveInCategoryMissStepIcon ]! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:24'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 17:26'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Category for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self categoryTitle
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString | 
			aStream nextPutAll: aString ].
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:00'!
hasKnownName
	^ self categoryTitle notNil! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:01'!
hasName
	"In that case it is category title"
	^ true! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:46'!
isCategoryDiveIn
	^ true! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

OrderedCollection subclass: #GTAAnnouncements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 11:38'!
fromDirectory: aFileReference
	"self fromDirectory: './gt/events/' asFileReference"
	^ self 
		withAll: (GTSpotterEventRecorder materializeObjectsFromDirectory: aFileReference)! !

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 11:38'!
fromLocalDirectory
	GTATool ensureLocalDirectory.
	^ self fromDirectory: './gt/events/' asFileReference! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:08'!
spotterDevelopers
	"self spotterDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				developers
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:07'!
spotterUsers
	"self spotterUsers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				users
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:10'!
spotterUsersAndDevelopers
	"self spotterUsersAndDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				withoutEventsBeforePharo4Release
					sessionsPerComputer
						"sessionsWithNumberOfInputsGreaterThenOne"! !

!GTAAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 11:45'!
developerUUIDs
	^ GTAConfiguration developerUUIDs! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:30'!
developers
	^ self select: [ :each | self developerUUIDs includes: each computerUUID asString ]! !

!GTAAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 12:42'!
numberOfComputers
	^ self perComputer size! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
perComputer
	^ (self groupedBy: [ :each | each computerUUID asString]) as: GTAAnnouncements! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:21'!
sessions
	^ GTSpotterSessionsBuilder fromEvents: (
			self flatCollect: #events as: OrderedCollection)! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 14:41'!
sessionsPerComputer
	| group computers |
	group := self perComputer.
	computers := group collect: [ :eachComputer |
		eachComputer sortByTimestamp.
		eachComputer sessions.
	] as: GTAComputers.
	computers := computers removeAllSuchThat: #isEmpty.
	computers do: [ :eachComputer | eachComputer computers: computers ].
	computers updateEvents.
	^ computers! !

!GTAAnnouncements methodsFor: 'sorting' stamp: 'JurajKubelka 3/29/2015 12:42'!
sortByTimestamp
	^ self sort: [ :a :b | a timestamp < b timestamp ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:31'!
users
	^ self select: [ :each | (self developerUUIDs includes: each computerUUID asString) not ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
withoutEmptyComputerUUID
	^ self select: [ :each | each computerUUID notNil and: [ (each computerUUID = 'nil') not ] ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/20/2015 10:30'!
withoutEventsBeforePharo4Release
	^ self select: [ :eachAnnouncement |
			eachAnnouncement latestUpdate >= GTAConfiguration pharo4HighestUpdate ]! !

OrderedCollection subclass: #GTABookmarks
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTABookmarks class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 18:17'!
from: aCollection computers: aCollection2 
	^ (self new: aCollection size + 10)
			from: aCollection computers: aCollection2;
			yourself! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 12:36'!
addComputer: aGTAComputer description: aString 
	| item |
	item := self add: (GTAComputerBookmark new item: aGTAComputer; description: aString; yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 12:36'!
addSession: aGTASession description: aString 
	| item |
	item := self add: (GTASessionBookmark new item: aGTASession; description: aString; yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/19/2015 17:10'!
addSomeSessions: aCollection description: aString 
	| item |
	item := self add: (GTASomeSessionsBookmark new
				item: aCollection;
				description: aString;
				yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 13:07'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTABookmarks methodsFor: 'initialization' stamp: 'JurajKubelka 5/20/2015 11:07'!
from: aCollection computers: aGTAComputers
	aCollection do: [ :eachBookmarkPath | | bookmark |
		bookmark := GTABookmark from: eachBookmarkPath computers: aGTAComputers.
		self add: bookmark.
	]! !

!GTABookmarks methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:59'!
hasRelatedTo: anObject 
	^ self anySatisfy: [ :eachBookmark | eachBookmark isRelatedTo: anObject ]! !

!GTABookmarks methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 11:04'!
relatedTo: anObject 
	^ (self select: [ :eachBookmark | eachBookmark isRelatedTo: anObject ]) as: OrderedCollection! !

!GTABookmarks methodsFor: 'removing' stamp: 'JurajKubelka 5/14/2015 13:04'!
removeBookmark: aBookmark
	| item |
	item := self remove: aBookmark.
	self announcer announce: GTAItemRemoved.
	^ item! !

!GTABookmarks methodsFor: 'storing' stamp: 'JurajKubelka 5/14/2015 12:51'!
save
	GTAConfiguration saveBookmarks: self.
	self announcer announce: GTASaved! !

OrderedCollection subclass: #GTACollection
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:07'!
duration
	^ self end - self start! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 17:26'!
end
	^ (self detectMax: #end) ifNil: [ 0 ] ifNotNil: [ :obj | obj end ]! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key
	^ self optionAt: key ifAbsent: [ nil ]! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key ifAbsent: absentBlock
	options ifNil: [ ^ absentBlock value ].
	^ options at: key ifAbsent: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:11'!
optionAt: key ifAbsentPut: absentBlock
	options ifNil: [ options := Dictionary new ].
	^ options at: key ifAbsentPut: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key put: value
	options ifNil: [ options := Dictionary new ].
	^ options at: key put: value! !

!GTACollection methodsFor: 'removing' stamp: 'JurajKubelka 5/27/2015 10:46'!
removeOptionKey: key 
	^ self removeOptionKey: key ifAbsent: [ "ignore" ]! !

!GTACollection methodsFor: 'removing' stamp: 'JurajKubelka 5/27/2015 10:46'!
removeOptionKey: key ifAbsent: absentBlock
	options ifNil: [ ^ absentBlock value].
	^ options removeKey: key ifAbsent: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 17:26'!
start
	^ (self detectMin: #start) ifNil: [ 0 ] ifNotNil: [ :obj | obj start ]! !

GTACollection subclass: #GTAEventCollection
	uses: TGTABookmarkIt + TGTSpotterCategoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAEventCollection class
	uses: TGTABookmarkIt classTrait + TGTSpotterCategoryView classTrait
	instanceVariableNames: ''!

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/26/2015 15:38'!
categoryLabel
	^ self optionAt: #categoryLabel! !

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/26/2015 15:38'!
categoryLabel: aString 
	^ self optionAt: #categoryLabel put: aString! !

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:33'!
computerUUID
	self ifEmpty: [ ^ 0 ].
	^ self any computerUUID! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:40'!
contextChanges
	^ self select: #isContextChanged! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:14'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesOut
	^ self select: #isDiveOut! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:55'!
finishedSearches
	^ self select: #isSearchFinished! !

!GTAEventCollection methodsFor: 'testing' stamp: 'JurajKubelka 4/9/2015 10:51'!
hasMissSteps
	^ self missSteps notEmpty! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:44'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:40'!
numberOfContextChanged
	^ self contextChanges size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 12:15'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesIn
	^ self divesIn size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesOut
	^ self divesOut size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:54'!
numberOfFinishedSearches
	^ self finishedSearches size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 4/9/2015 10:52'!
numberOfMissSteps
	^ self missSteps size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:43'!
numberOfUserSelections
	^ self userSelections size! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
sessionPopupText
	^ String streamContents: [ :aStream |
			self sessionPopupTextOn: aStream
		 ]! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
sessionPopupTextOn: aStream
	aStream
		nextPutAll: 'Duration: ';
		print: self duration;
		cr;
		nextPutAll: 'Events: ';
		print: self size;
		cr;
		nextPutAll: 'Number of user input changes: ';
		print: self numberOfContextChanged;
		cr;
		nextPutAll: 'Number of different search strings: ';
		print: self numberOfDifferentSearchStrings;
		cr;
		nextPutAll: 'Number of finished searches: ';
		print: self numberOfFinishedSearches;
		cr;
		nextPutAll: 'Number of user item selections: ';
		print: self numberOfUserSelections;
		cr;
		nextPutAll: 'Dive in/out: ';
		print: self numberOfDivesIn;
		nextPut: $/;
		print: self numberOfDivesOut;
		cr;
		"using of #i, etc."
		nextPutAll: (self isWithPreview ifTrue: [ 'With Preview' ] ifFalse: [ 'Without Preview' ])! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:44'!
userSelections
	^ self select: #isUserSelection! !

GTAEventCollection subclass: #GTASession
	uses: TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASession class
	uses: TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:16'!
activityView
	| builder |
	builder := GTATimelineBuilder new.
	builder 
		configuration: GTADefaultTimelineConfiguration uniqueInstance;
		events: self;
		build.
	GTAMenuBuilder new timelineBuilder: builder; build.
	builder view canvas focusOnCenterScaled.
	^ builder view.! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:18'!
activityView3
	"obsolete"
	^ GTSpotterTimeline viewOn: self! !

!GTASession methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 10:42'!
bookmarkIt
	self bookmarks
		addSession: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:40'!
bookmarks
	^ self computer bookmarks ! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:47'!
categoryLabels
	^ self categorySelections collect: #categoryLabel as: OrderedCollection! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:45'!
categorySelections
	^ self select: #isCategorySelection! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 10:50'!
closeActionSymbol
	self ifEmpty: [ ^ #empty ].
	^ self last closeActionSymbol! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 4/20/2015 11:28'!
computer
	^ self optionAt: #computer! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 4/20/2015 11:28'!
computer: aGTSpotterComputer
	^ self optionAt: #computer put: aGTSpotterComputer! !

!GTASession methodsFor: 'comparing' stamp: 'JurajKubelka 4/9/2015 20:19'!
deepestDiveIn
	^ self max: #diveInLevel! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 14:21'!
divesIn
	^ self select: #isDiveIn! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
end
	self ifEmpty: [ ^ 0 ].
	^ self last dateAndTimeWithFixedTimeZone! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorActivityView3In: composite
	<gtInspectorPresentationOrder: -5>
	"obsolete"
	composite roassal2
		title: 'Activity 3';
		initializeView: [ self activityView3 ]
		! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorActivityViewIn: composite
	<gtInspectorPresentationOrder: -6>
	composite roassal2
		title: 'Activity';
		initializeView: [ self activityView ]
		! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:28'!
gtInspectorEventsIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Events';
		display: [ :aSession | aSession ];
		column: 'Event' 
			evaluated: [ :each | each asEventAnalysisString ] width: 400;
		column: 'Time' 
			evaluated: [ :each | GTSpotterPrintDateAndTime yyyyMmDdAndHhMmSs: each dateAndTimeWithFixedTimeZone ]
			width: 120;
		withSmalltalkSearch;
		helpMessage: 'Given your INPUT, it executes: self select: [:each | INPUT ]';
		showOnly: 200! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 13:53'!
gtInspectorStrangeEventsIn: composite
	<gtInspectorPresentationOrder: 9>  
	^ (composite tree)
		title: 'Strange';
		display: [ :aSession | aSession select: #isStrange ];
		children: [ :eachChild |
			eachChild isString 
				ifTrue: [ #() ]
				ifFalse: [ eachChild strange ] ];
		format: [ :eachEvent | 
			eachEvent isString 
				ifTrue: [ eachEvent ]
				ifFalse: [ eachEvent asEventAnalysisString, 
								' with ', eachEvent strange size asString, ' strange observations.' ] ]! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorTreeEventsIn: composite
	<gtInspectorPresentationOrder: -8>  
	^ (composite tree)
		title: 'Tree';
		display: [ :aSession | aSession roots ];
		children: [ :eachChild |
			eachChild children ];
		format: [ :eachEvent | eachEvent asEventAnalysisString ]
		! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 16:29'!
hasDelayedExit
	^ self optionAt: #hasDelayedExit ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:53'!
hasSpecialKeywords
	^ self anySatisfy: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:19'!
imageHashes
	^ (self collect: #imageHash as: OrderedCollection) removeDuplicates! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 17:44'!
isComplexSession
	^ self isFirstLevelDiveInSession not and: [ 
		self isDirectSession not and: [ 
			self isEmptySession not and: [ 
				self hasDelayedExit not ] ] ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 16:09'!
isDirectSession
	^ self optionAt: #isDirectSession ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 10:49'!
isEmptySession
	^ self optionAt: #isEmptySession ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 17:06'!
isFirstLevelDiveInSession
	^ self optionAt: #isFirstLevelDiveInSession ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:45'!
isWithPreview
	^ (self contains: #isShowPreview) and: [ 
			(self contains: #isHidePreview) not ]! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 12:02'!
missSteps
	| collection |
	collection := self select: #isMissStep.
	collection computer: self computer.
	^ collection! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:50'!
previewString
	^ self isWithPreview
		ifTrue: [ 'yes' ]
		ifFalse: [ 'no' ]! !

!GTASession methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
printHumanReadableOn: aStream 
	self sessionPopupTextOn: aStream! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:29'!
removeHasDelayedExit
	^ self removeOptionKey: #hasDelayedExit! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:06'!
removeIsDirectSession
	^ self removeOptionKey: #isDirectSession! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 10:47'!
removeIsEmptySession
	^ self removeOptionKey: #isEmptySession! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 17:01'!
removeIsFirstLevelDiveInSession
	^ self removeOptionKey: #isFirstLevelDiveInSession! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 17:00'!
removeIsOneDiveInSession
	^ self removeOptionKey: #isOneDiveInSession! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 13:04'!
roots
	^ self select: #isRootEvent! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:10'!
searchStrings
	^ ((self select: #isContextChanged)
			flatCollect: #currentTextHashes as: Bag)! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/27/2015 10:56'!
select: aBlock
	| newCollection |
	newCollection := super select: aBlock.
	newCollection computer: self computer.
	^ newCollection! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/26/2015 15:40'!
sessionsPerCategoryLabel
	| labels col |
	labels := ((self select: #isCategorySelection) collect: #categoryLabel as: OrderedCollection) removeDuplicates.
	col := labels collect: [ :eachLabel | self categoryLabel: eachLabel; yourself ] as: GTASomeSessions.
	col computer: self computer.
	^ col! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:05'!
setDirectSession
	self optionAt: #isDirectSession put: true! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:28'!
setHasDelayedExit
	self optionAt: #hasDelayedExit put: true! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 10:48'!
setIsEmptySession
	self optionAt: #isEmptySession put: true! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 17:06'!
setIsFirstLevelDiveInSession
	self optionAt: #isFirstLevelDiveInSession put: true! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:57'!
specialKeywords
	^ self select: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first dateAndTimeWithFixedTimeZone! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 16:04'!
timelineView2
	^ self activityView! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 12:33'!
unknownNames
	^ self select: #hasUnknownName! !

!GTASession methodsFor: 'update' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateEvents
	^ GTSpotterSessionAnalysis updateOn: self! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:45'!
userQueryOrSelectionHashes
	^ self flatCollect: #userQueryOrSelectionHashes as: OrderedCollection ! !

GTAEventCollection subclass: #GTASomeSessions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASomeSessions subclass: #GTAComputer
	uses: TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAComputer class
	uses: TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTAComputer methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 12:23'!
bookmarkIt
	self bookmarks
		addComputer: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:41'!
bookmarks
	^ self computers bookmarks! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/26/2015 11:48'!
computer
	^ self! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:52'!
computers
	^ self optionAt: #computers! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:52'!
computers: aCollection 
	^ self optionAt: #computers put: aCollection! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:28'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 15:35'!
flatCollectEvents: aBlock 
	^ self flatCollect: [ :eachSession | eachSession select: aBlock ] as: OrderedCollection! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/12/2015 00:27'!
hasSessionsWithSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:54'!
hasSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self select: [ :each | each numberOfContextChanged > anInteger ]! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/11/2015 23:59'!
sessionsWithSpecialKeywords
	^ self select: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:43'!
updateEvents
	^ self do: #updateEvents! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:44'!
userQueryOrSelectionHashes
	^ self flatCollect: #userQueryOrSelectionHashes as: OrderedCollection! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/27/2015 17:11'!
activityView
	| composer builders |
	composer := RTComposer new.
	composer view @ RTZoomableView.
	self ifEmpty: [ ^ composer view ].
	builders := GTATimelineBuilders new.
	1 to: (self size min: 50) do: [ :index | | builder |
		builder := GTATimelineBuilder new.
		builder 
			view: composer view;
			configuration: GTADefaultTimelineConfiguration uniqueInstance;
			events: (self at: index);
			build.
		composer group: index.
		index > 1 ifTrue: [ composer move: index belowAlignFromLeft: index - 1 ].
		builders add: builder.
	 ].
	GTAMenuBuilder new timelineBuilder: builders; build.
	composer view canvas focusOnCenterScaled.
	^ composer view.! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
avgNumberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesIn) / self size! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
avgNumberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesOut) / self size! !

!GTASomeSessions methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 17:07'!
bookmarkIt
	self bookmarks
		addSomeSessions: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
bookmarks
	^ self computer bookmarks! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 18:07'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
computer
	^ self optionAt: #computer! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
computer: aCollection 
	^ self optionAt: #computer put: aCollection! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 14:23'!
divesIn
	^ self flatCollect: #divesIn as: OrderedCollection! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:11'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:10'!
gtInspectorActivityViewIn: composite
	<gtInspectorPresentationOrder: -6>
	composite roassal2
		title: 'Activity';
		initializeView: [ self activityView ]
		! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:11'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: -1>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:12'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Sessions';
		display: [ :aComputer | aComputer ];
		column: 'Start' 
			evaluated: [ :each | String streamContents: [ :aStream | | start |
											start := each start.
											start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [
													start asUTC printYMDOn: aStream.
													aStream nextPutAll: ', '.
													start asUTC printHMSOn: aStream ] ] ]
			width: 120;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each previewString ]
			width: 57;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 67;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Fin. Searches' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 83;
		column: 'Selections' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfUserSelections ]
			width: 70;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Close' 
			evaluated: [ :each | each closeActionSymbol ]
			width: 63;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		beMultiple;
		send: [ :result | GTAMultipleSelectionSendCommand selection: result in: self ];
		showOnly: 200! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:08'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: -8>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTASomeSessions methodsFor: 'testing' stamp: 'JurajKubelka 5/19/2015 15:04'!
isDeveloper
	^ GTAConfiguration isDeveloper: self computerUUID! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 15:06'!
missSteps
	^ self flatCollect: #missSteps as: GTASession! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesIn	! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesOut! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfEvents
	self ifEmpty: [ ^ 0 ].
	^ self sum: #size! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfPreviews
	^ self sessionsWithPreview size! !

!GTASomeSessions methodsFor: 'printing' stamp: 'JurajKubelka 5/26/2015 14:19'!
printHumanReadableOn: aStream
	| duration |
	aStream 
		nextPutAll: (self size pluralize: 'session');
		nextPutAll: ' from '; 
		print: self start asDate; 
		cr;
		nextPutAll: ' during '. 
	duration := self duration.
	self duration > 1 second ifTrue: [ duration := self duration truncateTo: 1 milliseconds ].
	self duration > 1 minute ifTrue: [ duration := self duration truncateTo: 1 second ].
	self duration > 1 hour ifTrue: [ duration := self duration truncateTo: 1 minute ].
	self duration > 1 day ifTrue: [ duration := self duration truncateTo: 1 hour ].
	duration printHumanReadableOn: aStream.
	aStream
		cr;
		print: self specialKeywords size; nextPutAll: ' special keywords'; cr;
		print: self divesIn size; nextPutAll: ' dives-in'; cr;
		print: self unknownNames size; nextPutAll: ' unknown items'
		! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 15:05'!
searchStrings
	^ self flatCollect: #searchStrings as: Bag! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/26/2015 11:20'!
sessionsPerCategoryLabel
	| dictionary |
	dictionary := Dictionary new.
	self  
		select: [ :eachSession | eachSession anySatisfy: #isCategorySelection ]
		thenDo: [ :eachSession | 
			eachSession categoryLabels asSet do: [ :eachLabel |
				dictionary 
					at: eachLabel
					ifPresent: [ :aCollection | aCollection add: eachSession ]
					ifAbsent: [ dictionary 
										at: eachLabel 
										put: (GTASomeSessions new
													add: eachSession;
													categoryLabel: eachLabel;
													computer: self computer;
													yourself) ] ] ].
	^ dictionary associations 
		collect: #value
		as: GTASomeSessions! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 15:05'!
sessionsWithPreview
	^ self select: #isWithPreview! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/18/2015 15:39'!
specialKeywords
	^ self flatCollect: #specialKeywords as: OrderedCollection! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 17:47'!
spentTime
	self ifEmpty: [ ^ 0 seconds ].
	^ self sum: #duration! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/20/2015 16:53'!
timelineView
	| builder minTime dataSetBuilder set objects |
	builder := RTTimeline new.
	minTime := self start asUnixTime.
	self size > 15 
		ifTrue: [ 
			dataSetBuilder := GTARoughDataSetBuilder new
				gap: self duration / 48;
				setSessionComparator;
				newGroupBlock: [ GTASomeSessions new computer: self; yourself ];
				yourself.
			dataSetBuilder objects: self; build.
			objects := dataSetBuilder groups collect: [ :eachGroup |
				eachGroup size = 1 ifTrue: [ eachGroup any ] ifFalse: [ eachGroup ] ] ]
		ifFalse: [ objects := self ].
	set := RTTimelineSet new.
	set 
		lineIdentifier: 1;
		objects: objects;
		start: [ :eachSession | eachSession start asUnixTime - minTime ];
		end: [ :eachSession | eachSession end asUnixTime - minTime ].
	set interaction popupText: #humanReadablePrintString.
	set shape color: (RTMultiLinearColorForIdentity new objects: objects).
	builder add: set.
	builder axisX 
		numberOfLabels: 5;
		labelRotation: -45;
		labelConversion: [ :unixTime | 
			GTADateAndTimeStringBuilder new
				dateAndTime: (DateAndTime fromUnixTime: unixTime + minTime);
				duration: self duration;
				numberOfLabels: 5;
				humanReadablePrintString ].
	builder timelineLabel: ''.
	builder build.
	GTAMenuTimelineBuilder new timelineBuilder: builder; build.
	^ builder ! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 12:35'!
unknownNames
	^ self flatCollect: #unknownNames as: OrderedCollection! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:03'!
userOrDeveloperString
	^ self isDeveloper
			ifTrue: [ 'dev' ]
			ifFalse: [ 'user' ]! !

GTACollection subclass: #GTASessions
	uses: TGTSpotterDurationView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASessions class
	uses: TGTSpotterDurationView classTrait
	instanceVariableNames: ''!

!GTASessions methodsFor: 'gt-inspector-extension' stamp: ''!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTASessions methodsFor: 'gt-inspector-extension' stamp: ''!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTASessions methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 11:20'!
numberOfEvents
	^ self sum: #size! !

!GTASessions methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 10:37'!
sessions
	^ self! !

GTACollection subclass: #GTASomeComputers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASomeComputers subclass: #GTAComputers
	uses: TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAComputers class
	uses: TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTAComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:13'!
bookmarks
	^ self optionAt: #bookmarks ifAbsentPut: [ GTAConfiguration loadBookmarks: self ]! !

!GTAComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/19/2015 14:35'!
gtInspectorBookmarksIn: composite
	<gtInspectorPresentationOrder: 9>
	(composite table)
		title: 'Bookmarks';
		display: [ :aComputers | aComputers bookmarks ];
		column: 'Type'
			evaluated: [ :each | each typeName ]
			width: 57;
		column: 'Garbage'
			evaluated: [ :each | each garbageString ]
			width: 57;
		column: 'Description'
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each description asString ];
		act: [ :aPresentation :aComputers | aComputers saveBookmarks ]
			icon: Smalltalk ui icons glamorousSave
			entitled: 'Save bookmarks';
		selectionPopulate: #selection
			entitled: 'Open bookmark'
			with: [ :aTable | aTable rawSelection gtInspectorInterestingObject ];
		selectionAct: [ :list :bookmark | 
				self toggleGarbage: list rawSelection.
				list update ]
			entitled: 'Toggle garbage';
		selectionAct: [ :list :bookmark | 
				self removeBookmark: list rawSelection.
				list update ]
			entitled: 'Remove bookmark';
		updateOn: GTACollectionAnnouncement 
			from: [ :aComputers | aComputers bookmarks announcer ];
		send: [ :result | result ifNotNil: [ result item ] ];
		showOnly: 50 ! !

!GTAComputers methodsFor: 'bookmarks' stamp: 'JurajKubelka 5/19/2015 10:35'!
removeBookmark: aGTABookmark 
	self bookmarks 
		removeBookmark: aGTABookmark;
		save.! !

!GTAComputers methodsFor: 'bookmarks' stamp: 'JurajKubelka 5/13/2015 18:42'!
saveBookmarks
	self bookmarks ifNotEmpty: [ self bookmarks save ]! !

!GTAComputers methodsFor: 'bookmarks' stamp: 'JurajKubelka 5/19/2015 10:28'!
toggleGarbage: aGTASessionBookmark 
	aGTASessionBookmark toggleGarbage.
	self saveBookmarks.! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
computerUUIDs
	^ self collect: #computerUUID as: OrderedCollection! !

!GTASomeComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:51'!
computers
	^ self optionAt: #computers! !

!GTASomeComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:51'!
computers: aCollection 
	^ self optionAt: #computers put: aCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
computersAndOnlySessionsWithSpecialKeywords
	^ self 
		select: [ :computer | computer hasSessionsWithSpecialKeywords ]
		thenCollect: [ :computer | 
			computer sessionsWithSpecialKeywords	]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 14:23'!
divesIn
	^ self flatCollect: #divesIn as: OrderedCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
flatCollectEvents: aBlock 
	^ self flatCollect: [ :eachComputer | eachComputer flatCollectEvents: aBlock ] as: OrderedCollection! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/20/2015 10:42'!
gtInspectorComputersIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Computers';
		display: [ :aComputer | aComputer ];
		column: 'Since' 
			evaluated: [ :each | String streamContents: [ :aStream | 
											each start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [ each start asUTC printYMDOn: aStream ] ] ]
			width: 67;
		column: 'Days' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration asDuration asDays rounded ] 
			width: 40;
		column: 'Spent' 
			evaluated: [ :each | each spentTime ] 
			width: 63;
		column: 'User' 
			evaluated: [ :each | each userOrDeveloperString ] 
			width: 50;
		column: 'Sessions' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] 
			width: 60;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfEvents ] 
			width: 50;
		column: 'Previews' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfPreviews ] 
			width: 60;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Dives Out' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesOut ]
			width: 63;
		column: 'Avg. D-In' 
			evaluated: [ :each | (each avgNumberOfDivesIn printShowingDecimalPlaces: 2)]
			width: 60;
		column: 'Avg. D-Out' 
			evaluated: [ :each | (each avgNumberOfDivesOut printShowingDecimalPlaces: 2) ]
			width: 67;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 60;
		beMultiple;
		send: [ :result | GTAMultipleSelectionSendCommand selection: result in: self as: GTASomeComputers ];
		showOnly: 100! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/20/2015 15:20'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: -8>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
missSteps
	^ self flatCollect: #missSteps as: GTASession! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged ! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfEvents
	^ self sum: [ :each | each numberOfEvents ]! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfMissSteps
	^ self missSteps size! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfSessions
	^ self sum: [ :each | each size ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessions
	^ self flatCollect: #yourself as: GTASessions! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self collect: [ :each | each copy sessionsWithNumberOfInputsGreaterThen: anInteger ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
specialKeywords
	^ self flatCollect: #specialKeywords as: OrderedCollection! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/20/2015 16:26'!
timelineView
	| builder minTime dataSetBuilder |
	builder := RTTimeline new.
	minTime := self start asUnixTime.
	dataSetBuilder := GTARoughDataSetBuilder new
		gap: self duration / 48;
		setSessionComparator;
		yourself.
	self reverseWithIndexDo: [ :eachComputer :index | | set objects |
		dataSetBuilder 
			objects: eachComputer; 
			newGroupBlock: [ GTASomeSessions new computer: eachComputer; yourself ];
			build.
		objects := dataSetBuilder groups collect: [ :eachGroup |
			eachGroup size = 1 ifTrue: [ eachGroup any ] ifFalse: [ eachGroup ] ].
		set := RTTimelineSet new.
		set
			lineIdentifier: index;
			objects: objects;
			start: [ :eachSession | eachSession start asUnixTime - minTime ];
			end: [ :eachSession | eachSession end asUnixTime - minTime ].
		set interaction popupText: #humanReadablePrintString.
		set shape color: (RTMultiLinearColorForIdentity new 
							command: [ :eachSession | objects indexOf: eachSession ]; 
							objects: (1 to: objects size);
							yourself).
		builder add: set.
	 ].
	builder axisX 
		numberOfLabels: 5;
		labelRotation: -45;
		labelConversion: [ :unixTime | 
			GTADateAndTimeStringBuilder new
				dateAndTime: (DateAndTime fromUnixTime: unixTime + minTime);
				duration: self duration;
				numberOfLabels: 5;
				humanReadablePrintString ].
	builder 
		timelineLabel: [ :lineIdentifier | String streamContents: [ :aStream |
				aStream 
					print: (self at: lineIdentifier) start asDate;
					space;
					nextPutAll: (self at: lineIdentifier) userOrDeveloperString ] ];
		extent: 400 @ ((self size * 14) max: 200).
	builder build.
	GTAMenuTimelineBuilder new timelineBuilder: builder; build.
	^ builder! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 12:35'!
unknownNames
	^ self flatCollect: #unknownNames as: OrderedCollection! !

!GTASomeComputers methodsFor: 'update' stamp: 'JurajKubelka 5/13/2015 19:43'!
updateEvents
	^ self do: #updateEvents! !

OrderedCollection subclass: #GTAGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:27'!
duration
	^ self end - self start! !

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:01'!
end
	^ self last end! !

!GTAGroup methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:10'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTAGroup methodsFor: 'printing' stamp: 'JurajKubelka 5/18/2015 11:28'!
printHumanReadableOn: aStream
	| duration |
	aStream 
		nextPutAll: (self size pluralize: 'event');
		nextPutAll: ' from '; 
		print: self start asDate; 
		cr;
		nextPutAll: ' during '. 
	duration := self duration.
	self duration > 1 second ifTrue: [ duration := self duration truncateTo: 1 milliseconds ].
	self duration > 1 minute ifTrue: [ duration := self duration truncateTo: 1 second ].
	self duration > 1 hour ifTrue: [ duration := self duration truncateTo: 1 minute ].
	self duration > 1 day ifTrue: [ duration := self duration truncateTo: 1 hour ].
	duration printHumanReadableOn: aStream! !

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:00'!
start
	^ self first start! !

OrderedCollection subclass: #GTAGroups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

OrderedCollection subclass: #GTATimelineBuilders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTATimelineBuilders methodsFor: 'adding' stamp: 'JurajKubelka 4/15/2015 16:03'!
addEdges
	self do: #addEdges! !

!GTATimelineBuilders methodsFor: 'building' stamp: 'JurajKubelka 4/16/2015 15:20'!
build
	self do: #build.
	self layoutSessions! !

!GTATimelineBuilders methodsFor: 'testing' stamp: 'JurajKubelka 4/15/2015 16:02'!
isWithEdges
	^ self anyOne isWithEdges! !

!GTATimelineBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:00'!
layout
	^ self anyOne layout! !

!GTATimelineBuilders methodsFor: 'layout' stamp: 'JurajKubelka 4/16/2015 15:19'!
layoutElements
	self do: #layoutElements.
	self layoutSessions! !

!GTATimelineBuilders methodsFor: 'layout' stamp: 'JurajKubelka 4/16/2015 15:19'!
layoutSessions
	| previousBuilder |
	self
		withIndexDo: [ :builder :index | 
			builder layoutElements.
			index > 1
				ifTrue: [ TRConstraint move: builder elements belowAlignFromLeft: previousBuilder elements gap: 20 ].
			previousBuilder := builder ]! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 15:59'!
logicalLayout
	self do: #logicalLayout! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:01'!
realLayout
	self do: #realLayout! !

!GTATimelineBuilders methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 4/16/2015 15:17'!
removeAllElementsAndEdges
	self do: #removeAllElementsAndEdges! !

!GTATimelineBuilders methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 16:02'!
removeEdges
	self do: #removeEdges! !

!GTATimelineBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/16/2015 15:16'!
shape
	^ self collect: #shape as: GTATimelineShapeBuilders! !

!GTATimelineBuilders methodsFor: 'signalling' stamp: 'JurajKubelka 4/15/2015 16:07'!
signalUpdate
	self ifEmpty: [ ^ self ].
	self view signalUpdate! !

!GTATimelineBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:58'!
view
	^ self anyOne view! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:08'!
withEdges
	self do: #withEdges! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:02'!
withoutEdges
	self do: #withoutEdges! !

OrderedCollection subclass: #GTATimelineShapeBuilders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTATimelineShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	self do: #flexibleResultShapes! !

!GTATimelineShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/15/2015 16:12'!
oblique
	self do: #oblique! !

!GTATimelineShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/15/2015 16:04'!
orthogonal
	self do: #orthogonal! !

!GTATimelineShapeBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:08'!
shape
	self ifEmpty: [ ^ nil ].
	^ self anyOne shape! !

RTBuilder subclass: #GTARoughTimeline
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughTimeline methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/11/2015 16:46'!
objects: aCollection
	objects := aCollection! !

RTBuilder subclass: #GTATimelineBuilder
	instanceVariableNames: 'events elements eventAnalyzer eventFilter analyze edges edgeShapeBuilder withEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTATimelineBuilder class methodsFor: 'api' stamp: 'JurajKubelka 4/13/2015 17:39'!
viewOn: objects
	| instance |
	instance := self new.
	instance
		events: objects;
		withEdges.
	instance interaction
		popupText: #asEventAnalysisString;
		draggable.
	^ instance
		build;
		view! !

!GTATimelineBuilder methodsFor: 'adding' stamp: 'JurajKubelka 4/14/2015 14:49'!
addEdges
	self edges ifNotEmpty: [ ^ self ].
	self buildEdges.! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/13/2015 16:41'!
analyze
	analyze := true! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 16:44'!
analyzeEvents
	self eventAnalyzer analyze: self events! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 16:43'!
analyzeEventsIfRequested
	analyze ifTrue: [ self analyzeEvents ]! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/14/2015 14:49'!
buildEdges
	| size |
	size := self elements size.
	size < 2
		ifTrue: [ ^ #() ].
	self elements
		withIndexDo: [ :element :index | 
			index < size
				ifTrue: [ self edgeFrom: element to: (self elements at: index + 1) ] ].
	^ self edges! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/14/2015 14:49'!
buildEdgesIfRequested
	withEdges
		ifFalse: [ ^ #() ].
	^ self buildEdges! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:09'!
buildElements
	| visibleEvents |
	visibleEvents := self visibleEvents.
	elements := self elementsWithInteractionOn: visibleEvents.
! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:52'!
configuration: aGTADefaultTimelineConfiguration 
	aGTADefaultTimelineConfiguration configure: self! !

!GTATimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/13/2015 16:55'!
createShapeBuilder
	^ super createShapeBuilder event; yourself! !

!GTATimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/13/2015 16:47'!
createView
	^ super createView @ RTDraggableView @ RTZoomableView.! !

!GTATimelineBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/14/2015 14:39'!
edgeFrom: source to: target 
	"source and target are elements"
	| newEdge |
	newEdge := self edgeShapeBuilder edgeFrom: source to: target.
	view add: newEdge.
	edges add: newEdge.
	^ newEdge! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 17:31'!
edgeShapeBuilder
	^ edgeShapeBuilder ifNil: [ edgeShapeBuilder := self newEdgeShapeBuilder ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 14:40'!
edges
	^ edges! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 15:29'!
elements
	elements ifNil: [ self buildElements ].
	^ elements! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:50'!
eventAnalyzer
	^ eventAnalyzer ifNil: [ eventAnalyzer := self newEventAnalyzer ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 15:10'!
eventFilter
	^ eventFilter ifNil: [ eventFilter := self newEventFilter ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:50'!
events
	^ events! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:48'!
events: aCollection 
	events := aCollection! !

!GTATimelineBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 4/14/2015 14:39'!
initialize
	super initialize.
	edges := OrderedCollection new.
	analyze := false.
	withEdges := false.! !

!GTATimelineBuilder methodsFor: 'testing' stamp: 'JurajKubelka 4/15/2015 15:05'!
isWithEdges
	^ withEdges ! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 15:16'!
layout
	^ layoutBuilder ifNil: [ layoutBuilder := self newLayoutBuilder ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 09:10'!
layout: aLayout
	^ layoutBuilder := aLayout! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:14'!
layoutElements
	self layoutElements: self elements! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:15'!
layoutElements: aCollection 
	self layout on: aCollection ! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/14/2015 14:29'!
logicalLayout
	^ self layout: GTAHorizontalDivingLineLayout new! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:01'!
newEdgeShapeBuilder
	^ self createShapeBuilder
		line;
		horizontalAttachPoint; 
		width: 1;
		yourself! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 14:50'!
newEventAnalyzer
	^ GTSpotterSessionAnalysis new! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 15:10'!
newEventFilter
	^ [ :session | session select: #isForTimelineView ]! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 09:07'!
newLayoutBuilder
	^ GTAHorizontalDivingLineLayout new center; yourself! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 15:13'!
realLayout
	^ self layout: GTAHorizontalRealTimelineLayout new! !

!GTATimelineBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/16/2015 15:16'!
removeAllElementsAndEdges
	self
		removeEdges;
		removeElements! !

!GTATimelineBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/14/2015 21:36'!
removeEdges
	self edges ifEmpty: [ ^ self ].
	"view removeEdges: self edges."
	self edges do: #remove.
	edges := OrderedCollection new.! !

!GTATimelineBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/14/2015 21:36'!
removeElements
	elements ifNil: [ ^ self ].
	self elements ifEmpty: [ ^ self ].
	self elements do: #remove.
	elements := nil! !

!GTATimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/16/2015 15:16'!
renderIn: aView
	self removeAllElementsAndEdges.
	self analyzeEventsIfRequested.
	aView addAll: self elements.
	self buildEdgesIfRequested.
	self layoutElements.! !

!GTATimelineBuilder methodsFor: 'signalling' stamp: 'JurajKubelka 4/14/2015 14:36'!
signalUpdate
	view signalUpdate ! !

!GTATimelineBuilder methodsFor: 'layout' stamp: 'JurajKubelka 4/14/2015 14:57'!
smoothLayoutTranslator
	self layout translator: (RTSmoothLayoutTranslator new nbCycles: 1).! !

!GTATimelineBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 4/13/2015 15:10'!
visibleEvents
	^ self eventFilter cull: self events cull: self! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/13/2015 17:09'!
withEdges
	withEdges := true! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:55'!
withEdges: aBoolean 
	withEdges := aBoolean! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/14/2015 15:17'!
withoutEdges
	withEdges := false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:27'!
analysisIcon
	^ GTSpotterEventIcons noIcon! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:47'!
asEventAnalysisString
	^ String streamContents: [ :stream |
			self eventAnalysisPrintOn: stream ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:38'!
children
	^ self infoAt: #sameLevelEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:17'!
cleanDiveInEvent: aDiveInEvent 
	^ self removeInfoAt: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:01'!
dateAndTimeWithFixedTimeZone
	| dateAndTime announcementTimestamp session dates |
	self infoAt: #dateAndTimeWithFixedTimeZone ifPresent: [ :value | ^ value ] ifAbsent: [ "ignore" ].
	dateAndTime := self dateAndTime.
	dateAndTime ifNil: [ ^ nil ].
	announcementTimestamp := self announcementTimestamp.
	announcementTimestamp ifNil: [ 
		^ dateAndTime translateTo: 0 ].
	dateAndTime asDate yyyymmdd = announcementTimestamp asDate yyyymmdd ifTrue: [ 
		^ self 
			infoAt: #dateAndTimeWithFixedTimeZone 
			put: (dateAndTime translateTo: announcementTimestamp offset) ].
	session := self session.
	session ifNil: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	dates := (session collect: #announcementTimestamp as: Set)
		select: [ :eachTimestamp | eachTimestamp asDate yyyymmdd = dateAndTime asDate yyyymmdd ].
	dates ifEmpty: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	^ self 
		infoAt: #dateAndTimeWithFixedTimeZone 
		put: (dateAndTime translateTo: dates any offset)! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:13'!
diveInEvent: aDiveInEvent 
	^ self infoAt: #diveInEvent put: aDiveInEvent.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:15'!
diveInLevel
	^ self parentEvent 
		ifNotNil: [ :obj | obj diveInLevel + 1 ]
		ifNil: [ 1 ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:35'!
elementNamePrintOn: aStream
	self elementName 
		ifNil: [ aStream nextPutAll: 'unknown element' ];
		ifNotNil: [ aStream nextPutAll: 'an element' ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:44'!
eventAnalysisPrintOn: aStream
	self printOn: aStream! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:50'!
eventTypePrintOn: aStream
	self eventType
		ifNotNil: [ :aSymbol |
			aStream
				cr;
				print: aSymbol;
				nextPutAll: ' event' ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 22:50'!
followingDifferentTime
	^ self infoAt: #followingDifferentTime ifAbsent: [ self dateAndTimeWithFixedTimeZone ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:35'!
hasElementName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:24'!
hasKnownName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:24'!
hasName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:32'!
hasUnknownName
	^ self hasName and: [ self hasKnownName not ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:07'!
isActOn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:46'!
isCategoryDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:49'!
isElementDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 16:11'!
isMissStep
	^ self infoAt: #isMissStep ifPresent: [ :obj | true ] ifAbsent: [ false ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:08'!
isRootEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | false ] ifAbsent: [ true ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:14'!
isSearchFinishedClass
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 10:37'!
isSpotterEvent
	^ true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:30'!
isStrange
	^ self infoAt: #strange ifPresent: [ :aCol | aCol notEmpty ] ifAbsent: [ false ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:44'!
markAsStrange: aString
	| stranges |
	stranges := self infoAt: #strange ifAbsentPut: [ OrderedCollection new ].
	stranges add: aString.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:36'!
myPositionAmongSameTimeEvents
	^ self infoAt: #myPositionAmongSameTimeEvents ifAbsent: [ 1 ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/11/2015 17:58'!
offset: aDuration 
	"Private: For test case purpose only."
	timestamp := timestamp + aDuration! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:13'!
parentEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | obj ] ifAbsent: [ nil ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition
	^ self infoAt: #relativeXPosition! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition: aDateAndTime 
	^ self infoAt: #relativeXPosition put: aDateAndTime! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:20'!
removeDiveInEvent
	^ self removeInfoKey: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:26'!
removeIsMissStep
	^ self removeInfoKey: #isMissStep! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:22'!
removeSameLevelEvents
	^ self removeInfoKey: #sameLevelEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:26'!
removeSameTimeEvents
	self removeInfoKey: #sameTimeEvents.
	self removeInfoKey: #myPositionAmongSameTimeEvents.
	self removeInfoKey: #followingDifferentTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedCategoryEvent
	^ self removeInfoKey: #selectedCategoryEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedElementEvents
	^ self removeInfoKey: #selectedElementEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:59'!
removeSession
	^ self removeInfoKey: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:24'!
removeStrange
	^ self removeInfoKey: #strange! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:18'!
sameTimeEvents
	^ self infoAt: #sameTimeEvents ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:16'!
sameTimeEvents: aCollection index: anInteger nextDateAndTime: aDateAndTime 
	self infoAt: #sameTimeEvents put: aCollection.
	self infoAt: #myPositionAmongSameTimeEvents put: anInteger.
	self infoAt: #followingDifferentTime put: aDateAndTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:02'!
session
	^ self infoAt: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:00'!
session: aSessionCollection 
	^ self infoAt: #session put: aSessionCollection.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:43'!
setMissStep
	^ self infoAt: #isMissStep put: true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:50'!
strange
	^ self infoAt: #strange ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:41'!
userQueryOrSelectionHashes
	"It returns array of hashes that represent user input (query) or user selections."
	^ #()! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:48'!
currentQueryHashes
	^ self stringHashesFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:36'!
currentQuerySizes
	^ self stringSizesFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 16:41'!
eventAnalysisPrintOn: aStream
	| categories | 
	categories := self notEmptyCategories.
	aStream
		nextPutAll: 'SearchFinished: ';
		nextPutAll: (query ifNil: [ 'no query' ] ifNotNil: [ 'with query' ]);
		nextPutAll: ', ';
		print: categories size;
		nextPutAll: ' categories, ';
		print: (self items ifEmpty: [ 0 ] ifNotEmpty: [ :col | col sum ]);
		nextPutAll: ' findings'.
	categories ifNotEmpty: [ | index |
		index := 1.
		aStream cr.
		categories 
			do: [ :category |
				index \\ 6 = 0 ifTrue: [ aStream cr ].
				aStream 
					nextPutAll: category key;
					nextPutAll: ' (';
					print: category value;
					nextPut: $).
				index := index + 1.
				 ] 
			separatedBy: [ aStream nextPutAll: ', ' ] ].
! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:15'!
hasKnownName
	^ self query notNil and: [ self processors notNil ]! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:14'!
hasName
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 15:27'!
isForTimelineView
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:13'!
isSearchFinishedClass
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 16:29'!
notEmptyCategories
	| notEmptyCategories |
	notEmptyCategories := OrderedCollection new.
	self processors ifNil: [ notEmptyCategories ].
	self processors pairsDo: [ :processor :items |
		items > 0 ifTrue: [ notEmptyCategories add: (processor -> items) ]
	].
	^ notEmptyCategories! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:49'!
userQueryOrSelectionHashes
	^ self currentQueryHashes! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:46'!
analysisIcon
	^ GTSpotterEventIcons exitIcon! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:05'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Close Spotter'! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:41'!
analysisIcon
	^ GTSpotterEventIcons diveOutIcon! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:22'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive Out: '.
	self elementNamePrintOn: aStream.
! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:19'!
hasKnownName
	^ self elementName notNil! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:19'!
hasName
	^ true! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

Announcement subclass: #GTACollectionAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTAItemAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTAItemRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTASaved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!TRShape methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 23:06'!
allVisibleColor: aColor
	self color = Color transparent 
			ifFalse: [ self color: aColor ]! !

!TRCompositeShape methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 23:07'!
allVisibleColor: aColor
	self shapes do: [ :aShape | aShape allVisibleColor: aColor ]! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:56'!
event
	self shape: GTAIconBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	self shape: GTAFlexibleResultIconBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:56'!
oblique
	self shape: GTAIconBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:57'!
orthogonal
	self shape: GTAOrthogonalIconBuilder new! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:45'!
analysisIcon
	^ GTSpotterEventIcons selectedCandidateChangedIcon! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:50'!
categoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:50'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Selection of '.
	self elementNamePrintOn: aStream.
	self selectedCategoryLabel ifNotNil: [ :aLabelString |
		aStream
			cr
			nextPutAll: 'in category ';
			nextPutAll: aLabelString ].
	self eventTypePrintOn: aStream.
! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 15:40'!
existsUserSelectionsOfTheSameElement
	| index |
	index := self session identityIndexOf: self.
	^ self session anySatisfy: [ :each | 
			((each isUserSelectionClass and: [ 
				each elementName = self elementName ]) 
					and: [ (each == self) not ]) 
						and: [ (self session identityIndexOf: each) < index ] ] ! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:23'!
hasKnownName
	^ self elementName notNil! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:18'!
hasName
	^ true! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isUserSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:42'!
isInTheSameCategoryAsPreviousSelection
	^ self selectedCategoryLabel = self previousSelection selectedCategoryLabel! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:38'!
previousSelection
	^ self infoAt: #previousSelection ifAbsent: [ nil ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:37'!
previousSelection: aGTSpotterRecorderSelectedCandidateChangedEvent 
	self infoAt: #previousSelection put: aGTSpotterRecorderSelectedCandidateChangedEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:38'!
removePreviousSelection
	^ self removeInfoKey: #previousSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:06'!
selectedCategoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:48'!
selectedCategoryEvent: anEvent
	self infoAt: #selectedCategoryEvent put: anEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:07'!
selectedCategoryLabel
	^ self selectedCategoryEvent ifNotNil: [ :catEvent | catEvent categoryLabel ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 16:06'!
userSelectionsOfTheSameElement
	| index |
	index := self session identityIndexOf: self.
	^ self session select: [ :each | 
			((each isUserSelectionClass and: [ 
				each elementName = self elementName ]) 
					and: [ (each == self) not ]) 
						and: [ (self session identityIndexOf: each) < index ] ] ! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:47'!
analysisIcon
	^ GTSpotterEventIcons actOnIcon! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:26'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Act On: '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:06'!
hasKnownName
	"It is a hash"
	^ self elementName notNil! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:05'!
hasName
	"It is a hash"
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:07'!
isActOn
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:24'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:35'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTSpotterEventIcons diveInElementIcon ]
			ifTrue: [ GTSpotterEventIcons diveInElementMissStepIcon ]! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:25'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 17:25'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Element for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:03'!
hasKnownName
	"In that case a hash"
	^ self elementName notNil! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:03'!
hasName
	"In that case a hash"
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:49'!
isElementDiveIn
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:51'!
elementSelectionEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:04'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Category: '.
	self categoryLabel
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString |
			aStream 
				nextPutAll: aString;
				nextPutAll: ' with ';
				print: self elementCountOrZero;
				nextPutAll: ' spotted and ';
				print: self selectedElementEvents size;
				nextPutAll: ' selected elements' ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:09'!
hasKnownName
	"It is a category name"
	^ self categoryLabel notNil! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:08'!
hasName
	"It is a category name"
	^ true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:40'!
markAsStrange
	^ self infoAt: #strange put: true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:42'!
selectedElementEvent: anEvent
	| elements |
	elements := self infoAt: #selectedElementEvents ifAbsentPut: [ OrderedCollection new ].
	elements add: anEvent! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:02'!
selectedElementEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

TestCase subclass: #GTAIconBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAIconBuilderTest commentStamp: '<historical>' prior: 0!
A GTATimelineIconBuilderTest is a test class for testing the behavior of GTATimelineIconBuilder!

!GTAIconBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/19/2015 13:56'!
setUp
	super setUp.
	builder := GTAIconBuilder new.
	! !

!GTAIconBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 4/11/2015 20:05'!
testShapeFor
	| shape view |
	view := RTView new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		shape := builder shapeFor: eachClass new.
		shape ifNotNil: [
			view add: shape element ]
	].
	RTHorizontalLineLayout on: view elements.
	view! !

TestCase subclass: #GTARoughDataSetBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughDataSetBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:20'!
dateAndTimes
	^ OrderedCollection new
		add: (DateAndTime year: 2015 month: 01 day: 02);
		add: (DateAndTime year: 2015 month: 01 day: 03);
		add: (DateAndTime year: 2015 month: 01 day: 05);
		add: (DateAndTime year: 2015 month: 01 day: 14);
		add: (DateAndTime year: 2015 month: 02 day: 07);
		add: (DateAndTime year: 2015 month: 02 day: 10);
		add: (DateAndTime year: 2015 month: 02 day: 15);
		add: (DateAndTime year: 2015 month: 03 day: 30);
		yourself! !

!GTARoughDataSetBuilderTest methodsFor: 'private' stamp: 'JurajKubelka 5/11/2015 17:30'!
session: aCollection offset: aDuration 
	aCollection do: [ :eachEvent |
		eachEvent offset: aDuration
	 ].
	^ aCollection! !

!GTARoughDataSetBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:29'!
sessions
	^ OrderedCollection new
		add: (self session: GTASessionExamples session1 offset: -30 days);
		add: (self session: GTASessionExamples session1 offset: -28 days);
		add: (self session: GTASessionExamples session1 offset: -15 days);
		add: (self session: GTASessionExamples session1 offset: -5 days);
		add: (self session: GTASessionExamples session1 offset: -1 days);
		yourself! !

!GTARoughDataSetBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 5/11/2015 16:47'!
setUp
	super setUp.
	builder := GTARoughDataSetBuilder new.! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 18:14'!
testBuild
	| objects |
	objects := #(0 1 2 3   13 15 17   23   29 30).
	builder
		objects: objects;
		gap: 5;
		build.
	self assert: builder numberOfGroups equals: 4.
	self assert: builder groups first size equals: 4.
	self assert: builder groups second size equals: 3.
	self assert: builder groups third size equals: 1.
	self assert: builder groups fourth size equals: 2.
	self assert: builder groups first asArray equals: #(0 1 2 3).
	self assert: builder groups second asArray equals: #(13 15 17).
	self assert: builder groups third asArray equals: #(23).
	self assert: builder groups fourth asArray equals: #(29 30).! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 18:14'!
testBuildDateAndTimes
	| objects |
	objects := self dateAndTimes.
	builder
		objects: objects;
		gap: 2 weeks;
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 4.
	self assert: builder groups second size equals: 3.
	self assert: builder groups third size equals: 1.
! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/14/2015 17:49'!
testBuildSessions
	| objects |
	objects := self sessions.
	builder
		objects: objects;
		gap: 1 week;
		setSessionComparator;
		groupClass: GTASomeSessions;
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 2.
	self assert: builder groups second size equals: 1.
	self assert: builder groups third size equals: 2.
	self assert: (builder groups allSatisfy: [ :eachGroup | eachGroup class = GTASomeSessions ]).
! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/14/2015 17:59'!
testBuildSessions2
	| objects |
	objects := self sessions.
	builder
		objects: objects;
		gap: 1 week;
		setSessionComparator;
		newGroupBlock: [ GTASomeSessions new ];
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 2.
	self assert: builder groups second size equals: 1.
	self assert: builder groups third size equals: 2.
	self assert: (builder groups allSatisfy: [ :eachGroup | eachGroup class = GTASomeSessions ]).
! !

TestCase subclass: #GTATimelineBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTATimelineBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:42'!
session1
	^ GTASessionExamples session1! !

!GTATimelineBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/13/2015 17:42'!
setUp
	super setUp.
	builder := GTATimelineBuilder new.! !

!GTATimelineBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 16:11'!
testBuild
	| events |
	events := GTASession new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		events add: eachClass new.
	].
	builder events: events.
	builder build.
	builder view.! !

!GTATimelineBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 4/13/2015 17:43'!
testBuildSession1
	| events |
	events := self session1.
	builder
		events: events;
		analyze;
		withEdges.
	builder interaction 
		popupText: #asEventAnalysisString;
		draggable.
	builder build.
	"builder view inspect."! !

TestCase subclass: #GTSpotterPrintDateAndTimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterPrintDateAndTimeTest commentStamp: '<historical>' prior: 0!
A GTSpotterPrintDateAndTimeTest is a test class for testing the behavior of GTSpotterPrintDateAndTime!

!GTSpotterPrintDateAndTimeTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 13:44'!
testUCTPlus1
	| dateAndTime string |
	dateAndTime := '2015-03-27T14:59:05.524852+01:00' asDateAndTime.
	string := GTSpotterPrintDateAndTime yyyyMmDdAndHhMmSs: dateAndTime.
	self assert: string equals: '2015-03-27, 13:59:05'.! !

TestCase subclass: #GTSpotterSessionAnalysisTest
	instanceVariableNames: 'analysis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterSessionAnalysisTest commentStamp: '<historical>' prior: 0!
A GTSpotterDiveInLevelCommandTest is a test class for testing the behavior of GTSpotterDiveInLevelCommand!

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session1
	^ GTASessionExamples session1! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session2
	^ GTASessionExamples session2! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session3
	^ GTASessionExamples session3! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:55'!
session4
	^ GTASessionExamples session4! !

!GTSpotterSessionAnalysisTest methodsFor: 'running' stamp: 'JurajKubelka 3/31/2015 13:24'!
setUp
	super setUp.
	analysis := GTSpotterSessionAnalysis new.
	! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/12/2015 13:58'!
testCategoriesSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 5) elementSelectionEvents size equals: 3.
	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).
	self assert: (session at: 5) elementSelectionEvents third equals: (session at: 8).
	self assert: (session at: 9) categoryEvent equals: (session at: 10).
	self assert: (session at: 10) elementSelectionEvents size equals: 1.
	self assert: (session at: 10) elementSelectionEvents first equals: (session at: 9).
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/12/2015 14:14'!
testCategoriesSession4
	| session |
	analysis session: self session4.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 7) categoryEvent equals: (session at: 5).
	self assert: (session at: 8) categoryEvent equals: (session at: 9).
	self assert: (session at: 12) categoryEvent equals: (session at: 9).
	self assert: (session at: 13) categoryEvent equals: (session at: 14).
	self assert: (session at: 16) categoryEvent equals: (session at: 14).
	self assert: (session at: 17) categoryEvent equals: (session at: 14).
	self assert: (session at: 18) categoryEvent equals: (session at: 14).
	self assert: (session at: 19) categoryEvent equals: (session at: 14).

	self assert: (session at: 5) elementSelectionEvents size equals: 2.
	self assert: (session at: 9) elementSelectionEvents size equals: 2.
	self assert: (session at: 14) elementSelectionEvents size equals: 5.

	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).

	self assert: (session at: 9) elementSelectionEvents first equals: (session at: 8).
	self assert: (session at: 9) elementSelectionEvents second equals: (session at: 12).

	self assert: (session at: 14) elementSelectionEvents first equals: (session at: 13).
	self assert: (session at: 14) elementSelectionEvents second equals: (session at: 16).
	self assert: (session at: 14) elementSelectionEvents third equals: (session at: 17).
	self assert: (session at: 14) elementSelectionEvents fourth equals: (session at: 18).
	self assert: (session at: 14) elementSelectionEvents fifth equals: (session at: 19).
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:28'!
testMissStepsSession1
	| session |
	analysis session: self session1.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 27.
	self assert: session numberOfMissSteps equals: 1.
	self assert: (session at: 6) isMissStep.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:29'!
testMissStepsSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: session numberOfMissSteps equals: 0.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:04'!
testMissStepsSession3
	| session |
	analysis session: self session3.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 9) isMissStep.
	self deny: (session at: 16) isMissStep.
	self assert: session numberOfMissSteps equals: 1.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 3/31/2015 13:41'!
testRootsSession1
	| roots |
	analysis session: self session1.
	analysis execute.
	roots := analysis session roots.
	self assert: roots size equals: 11.
	self assert: (roots at: 6) children size equals: 4.
	self assert: (roots at: 1) children size equals: 0.
	self assert: (roots at: 7) children size equals: 8.
	self assert: ((roots at: 7) children at: 4) children size equals: 4.
! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:44'!
analysisIcon
	^ GTSpotterEventIcons contextChangedIcon! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/27/2015 11:05'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Query: '.
	self currentTextSizes 
			ifEmpty: [ aStream nextPutAll: 'no input' ]
			ifNotEmpty: [ :aCollection | 
					aStream
						print: aCollection size;
						nextPutAll: (aCollection size = 1 
											ifTrue: [ ' word of size ' ] 
											ifFalse: [ ' words, each of size: ' ]).
				aCollection 
					do: [ :eachSize | aStream print: eachSize ] 
					separatedBy: [ aStream space ].
				self hasCurrentTextSpecials ifTrue: [ 
					aStream nextPutAll: ', with #keyword' ] ]! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isContextChanged! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:41'!
userQueryOrSelectionHashes
	^ self currentTextHashes ! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:38'!
analysisIcon
	^ GTSpotterEventIcons hidePreviewIcon! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Hide Preview'! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

Object subclass: #GTAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 10:11'!
developerUUIDs
	"
	GTSpotterEventRecorderSettings ensureComputerID.
	GTSpotterEventRecorderSettings uniqueInstance computerUUID.
	"
	^ #( 	'58d42da6-c993-4ad1-8624-5fd628793610' 
			'8c7d33b4-1025-42b3-8dc4-4a2bb32c5a42'
			'4483f704-6909-45d7-9367-869a5850c3e8'
			'52fe7c39-9c98-4fa7-a883-a8b2cabe84db'
			'69202c73-b32f-4968-aaf1-0666d421ea57'
			'0cd69f50-ad08-8c47-84ec-329e2210a2f2'
			'29d8c44d-c6da-4026-bf49-c3b0c25625db'
		)! !

!GTAConfiguration class methodsFor: 'testing' stamp: 'JurajKubelka 5/13/2015 11:01'!
isDeveloper: anUUID
	^ self developerUUIDs includes: anUUID asString! !

!GTAConfiguration class methodsFor: 'api' stamp: 'JurajKubelka 5/20/2015 10:51'!
loadBookmarks: aGTAComputers
	| paths |
	paths := FLMaterializer materializeFromByteArray: self savedBookmarks.
	^ GTABookmarks from: paths computers: aGTAComputers! !

!GTAConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 10:45'!
pharo4HighestUpdate
	"Release date: 2015-04-16
	See: http://forum.world.st/ANN-Pharo-4-0-is-released-td4819876.html
	We referes to 40610 that was released on 2015-04-23."
	^ 40610! !

!GTAConfiguration class methodsFor: 'api' stamp: 'JurajKubelka 5/20/2015 10:49'!
saveBookmarks: aGTABookmarks
	| paths methodSource |
	paths := aGTABookmarks collect: [ :each | each path ] as: Array.
	paths := FLSerializer serializeToByteArray: paths.
 	methodSource := String streamContents: [ :aStream |
		aStream
			nextPutAll: 'savedBookmarks'; cr; 
			tab; nextPutAll: '"Automatically created by class method #saveBookmarks."'; cr;
			tab; nextPutAll: '^ '.
		paths storeOn: aStream. 			
	 ].
	self class compile: methodSource classified: 'stored bookmarks'.! !

!GTAConfiguration class methodsFor: 'stored bookmarks' stamp: 'JurajKubelka 5/27/2015 17:03'!
savedBookmarks
	"Automatically created by class method #saveBookmarks."
	^ #[70 85 69 76 0 194 0 0 0 5 192 0 0 0 0 0 0 0 7 20 70 76 71 108 111 98 97 108 67 108 97 115 115 67 108 117 115 116 101 114 0 0 0 9 4 84 114 117 101 23 71 84 65 83 111 109 101 83 101 115 115 105 111 110 115 66 111 111 107 109 97 114 107 5 70 97 108 115 101 15 85 110 100 101 102 105 110 101 100 79 98 106 101 99 116 5 65 114 114 97 121 19 71 84 65 67 111 109 112 117 116 101 114 66 111 111 107 109 97 114 107 10 66 121 116 101 83 116 114 105 110 103 18 71 84 65 83 101 115 115 105 111 110 66 111 111 107 109 97 114 107 11 68 97 116 101 65 110 100 84 105 109 101 22 70 76 72 111 111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 1 0 3 22 70 76 72 111 111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 106 0 7 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 49 73 32 117 115 101 32 116 104 114 101 101 32 115 101 115 115 105 111 110 115 32 111 102 32 105 116 32 102 111 114 32 116 104 101 32 86 105 115 115 111 102 116 32 112 97 112 101 114 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 25 67 111 109 112 108 101 120 32 115 101 97 114 99 104 32 119 105 116 104 32 65 99 116 79 110 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 75 87 101 32 115 104 111 117 108 100 32 114 101 109 111 118 101 32 115 101 115 115 105 111 110 115 32 119 105 116 104 32 117 110 107 110 111 119 110 32 101 108 101 109 101 110 116 115 32 105 110 32 100 105 118 101 45 105 110 44 32 105 110 32 97 99 116 45 111 110 44 32 101 116 99 46 34 65 100 100 101 100 32 97 116 32 50 48 49 53 45 48 53 45 50 55 84 49 55 58 48 51 58 51 56 45 48 51 58 48 48 18 83 105 109 112 108 101 32 40 116 111 112 32 108 101 118 101 108 41 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 98 48 55 55 56 57 54 97 45 97 102 57 97 45 52 51 54 52 45 98 53 57 97 45 56 102 97 98 48 57 52 102 56 102 57 56 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 27 69 109 112 116 121 32 115 101 115 115 105 111 110 32 119 105 116 104 32 112 114 101 118 105 101 119 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 34 69 109 112 116 121 32 115 101 115 115 105 111 110 32 119 105 116 104 32 111 110 101 45 119 111 114 100 32 113 117 101 114 121 46 95 82 101 109 111 118 101 32 116 104 105 115 32 107 105 110 100 32 111 102 32 115 101 115 115 105 111 110 115 44 32 98 101 99 97 117 115 101 32 117 115 101 114 32 111 110 108 121 32 111 112 101 110 115 32 97 110 100 32 99 108 111 115 101 115 32 83 112 111 116 116 101 114 46 13 78 111 32 114 101 97 115 111 110 32 116 111 32 107 101 101 112 32 105 116 46 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 53 99 101 51 57 50 50 50 45 101 50 101 57 45 52 52 49 97 45 98 56 55 55 45 100 51 99 97 56 52 98 101 53 100 55 53 6 68 105 114 101 99 116 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 41 82 101 109 111 118 101 32 105 116 44 32 116 104 101 114 101 32 97 114 101 32 111 110 108 121 32 112 114 101 118 105 101 119 32 111 110 47 111 102 102 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 18 83 105 109 112 108 101 32 40 116 111 112 32 108 101 118 101 108 41 24 67 111 109 112 108 101 120 32 115 101 97 114 99 104 32 119 105 116 104 32 69 120 105 116 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 34 65 100 100 101 100 32 97 116 32 50 48 49 53 45 48 53 45 49 57 84 49 55 58 48 56 58 50 52 45 48 51 58 48 48 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 40 73 116 32 117 115 101 115 32 100 105 118 101 115 45 105 110 32 97 110 100 32 115 101 118 101 114 97 108 32 99 97 116 101 103 111 114 105 101 115 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 55 65 32 108 111 116 32 111 102 32 99 97 116 101 103 111 114 105 101 115 32 97 114 101 32 98 114 111 119 115 101 100 46 13 73 110 116 101 114 101 115 116 105 110 103 32 117 115 101 32 99 97 115 101 115 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 6 68 105 114 101 99 116 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 55 69 120 97 109 112 108 101 32 111 102 32 112 97 115 116 105 110 103 32 85 82 76 32 119 105 116 104 32 114 101 109 111 116 101 32 80 108 97 121 103 114 111 117 110 100 32 99 111 110 116 101 110 116 115 46 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 97 102 101 48 97 50 45 99 51 53 101 45 52 51 99 56 45 97 57 52 53 45 51 102 98 51 50 51 102 51 98 102 98 56 30 72 105 115 116 111 114 121 32 97 110 100 32 99 97 108 99 117 108 97 116 111 114 32 114 101 115 117 108 116 115 51 82 101 109 111 118 101 32 115 117 99 104 32 115 101 115 115 105 111 110 115 46 32 73 116 32 105 115 32 111 110 108 121 32 111 112 101 110 101 100 32 97 110 100 32 99 108 111 115 101 100 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 94 73 116 32 105 115 32 97 32 115 105 109 112 108 101 115 116 32 101 120 97 109 112 108 101 32 111 102 32 117 115 105 110 103 32 115 112 111 116 116 101 114 58 32 73 116 32 114 101 117 115 101 32 116 104 101 32 102 105 114 115 116 32 105 116 101 109 32 105 110 32 99 97 116 101 103 111 114 121 32 99 97 108 108 101 100 32 72 105 115 116 111 114 121 46 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 22 70 76 72 111 111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 1 153 0 9 0 37 126 82 16 170 111 8 1 26 26 255 213 208 0 0 0 0 0 37 126 15 0 0 0 0 0 230 37 0 14 16 0 0 0 0 0 37 126 70 55 96 151 8 0 176 131 255 213 208 0 0 0 0 0 37 126 60 54 92 35 64 0 241 252 0 28 32 0 0 0 0 0 37 126 59 14 235 105 136 0 161 158 0 28 32 0 0 0 0 0 37 126 82 16 168 154 72 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 169 148 72 1 26 26 255 213 208 0 0 0 0 0 37 126 60 45 211 192 32 0 118 59 0 28 32 0 0 0 0 0 37 126 60 8 187 4 16 0 181 65 0 28 32 0 0 0 0 0 37 126 61 56 72 28 144 0 193 85 0 28 32 0 0 0 0 0 37 126 59 48 237 88 72 0 203 22 0 28 32 0 0 0 0 0 37 126 82 16 167 168 24 1 26 26 255 213 208 0 0 0 0 0 37 126 29 0 0 0 0 1 27 146 0 28 32 0 0 0 0 0 37 126 68 3 189 191 152 1 37 99 255 213 208 0 0 0 0 0 37 126 69 24 248 120 168 0 206 94 255 213 208 0 0 0 0 0 37 126 59 37 58 66 24 0 135 77 0 28 32 0 0 0 0 0 37 126 62 45 28 59 168 0 209 100 0 28 32 0 0 0 0 0 37 126 62 5 88 194 88 1 27 52 0 28 32 0 0 0 0 0 37 126 82 46 66 100 88 0 197 123 255 213 208 0 0 0 0 0 37 126 62 44 42 156 48 0 212 110 0 28 32 0 0 0 0 0 37 126 60 33 99 167 56 0 239 128 0 28 32 0 0 0 0 0 37 126 82 16 188 3 8 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 55 56 1 26 26 255 213 208 0 0 0 0 0 37 126 62 37 240 157 176 1 36 230 0 28 32 0 0 0 0 0 37 126 82 16 196 251 232 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 179 41 104 1 26 26 255 213 208 0 0 0 0 0 37 126 59 19 99 93 24 0 184 63 0 28 32 0 0 0 0 0 37 126 82 16 177 92 120 1 26 26 255 213 208 0 0 0 0 0 37 126 69 20 189 9 72 0 192 204 255 213 208 0 0 0 0 0 37 126 82 16 196 29 64 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 78 168 1 26 26 255 213 208 0 0 0 0 0 37 126 69 45 63 25 112 0 209 21 255 213 208 0 0 0 0 0 37 126 82 16 175 112 72 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 194 76 104 1 26 26 255 213 208 0 0 0 0 0 37 126 79 26 21 39 144 0 166 8 0 28 32 0 0 0 0 0 37 126 59 57 13 237 48 0 127 139 0 28 32 0 0 0 0 0 37 126 82 16 195 66 128 1 26 26 255 213 208 0 0 0 0 0 37 126 63 44 37 154 240 0 224 64 0 28 32 0 0 0 0 0 37 126 82 16 176 125 208 1 26 26 255 213 208 0 0 0 0 0 37 126 61 28 245 229 8 0 137 144 0 28 32 0 0 0 0 0 37 126 82 16 193 86 80 1 26 26 255 213 208 0 0 0 0 0 37 126 60 50 25 245 80 0 242 16 0 28 32 0 0 0 0 0 37 126 82 16 174 145 160 1 26 26 255 213 208 0 0 0 0 0 37 126 60 0 8 198 24 0 179 255 0 28 32 0 0 0 0 0 37 126 82 16 173 155 136 1 26 26 255 213 208 0 0 0 0 0 37 126 60 20 137 227 136 0 168 3 0 28 32 0 0 0 0 0 37 126 82 16 172 184 248 1 26 26 255 213 208 0 0 0 0 0 37 126 60 2 172 99 32 0 209 25 0 28 32 0 0 0 0 0 37 126 68 35 27 11 152 1 10 26 255 213 208 0 0 0 0 0 37 126 82 16 171 218 80 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 170 232 32 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 169 23 72 1 26 26 255 213 208 0 0 0 0 0 37 126 68 43 3 59 0 1 54 36 255 213 208 0 0 0 0 0 37 126 82 16 170 13 96 1 26 26 255 213 208 0 0 0 0 0 37 126 59 36 85 111 248 0 128 29 0 28 32 0 0 0 0 0 37 126 82 16 166 119 104 1 26 26 255 213 208 0 0 0 0 0 37 126 59 34 57 62 232 0 126 210 0 28 32 0 0 0 0 0 37 126 69 28 206 13 208 0 248 4 255 213 208 0 0 0 0 0 37 126 59 9 190 98 128 0 135 242 0 28 32 0 0 0 0 0 37 126 82 16 168 56 160 1 26 26 255 213 208 0 0 0 0 0 37 126 62 12 227 233 88 1 26 22 0 28 32 0 0 0 0 0 37 126 63 8 156 225 56 0 219 144 0 28 32 0 0 0 0 0 37 126 60 43 102 82 48 0 134 4 0 28 32 0 0 0 0 0 37 126 74 20 208 160 232 0 141 232 0 28 32 0 0 0 0 0 37 126 59 24 53 216 112 0 127 232 0 28 32 0 0 0 0 0 37 126 62 58 66 117 144 0 213 154 0 28 32 0 0 0 0 0 37 126 82 16 179 162 128 1 26 26 255 213 208 0 0 0 0 0 37 126 70 39 205 194 32 0 176 217 255 213 208 0 0 0 0 0 37 126 82 16 187 161 96 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 177 213 144 1 26 26 255 213 208 0 0 0 0 0 37 126 69 3 72 104 136 1 6 21 255 213 208 0 0 0 0 0 37 126 82 16 196 154 64 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 199 192 1 26 26 255 213 208 0 0 0 0 0 37 126 82 52 18 55 40 0 197 203 255 213 208 0 0 0 0 0 37 126 82 16 176 0 208 1 26 26 255 213 208 0 0 0 0 0 37 126 59 18 232 206 24 0 140 147 0 28 32 0 0 0 0 0 37 126 82 16 176 250 208 1 26 26 255 213 208 0 0 0 0 0 37 126 59 21 243 114 32 0 134 230 0 28 32 0 0 0 0 0 37 126 82 16 195 187 152 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 167 50 232 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 175 14 160 1 26 26 255 213 208 0 0 0 0 0 37 126 59 51 108 160 136 0 129 167 0 28 32 0 0 0 0 0 37 126 82 16 193 234 192 1 26 26 255 213 208 0 0 0 0 0 37 126 61 30 17 75 208 0 137 160 0 28 32 0 0 0 0 0 37 126 69 54 221 175 80 0 197 125 255 213 208 0 0 0 0 0 37 126 82 16 194 224 216 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 24 64 1 26 26 255 213 208 0 0 0 0 0 37 126 62 30 99 48 168 1 53 191 0 28 32 0 0 0 0 0 37 126 61 56 15 171 88 0 137 83 0 28 32 0 0 0 0 0 37 126 82 16 174 47 248 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 173 53 248 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 172 87 80 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 171 97 56 1 26 26 255 213 208 0 0 0 0 0 37 126 59 22 52 138 48 0 193 128 0 28 32 0 0 0 0 0 37 126 59 13 46 45 16 0 134 188 0 28 32 0 0 0 0 0 37 126 82 16 170 134 120 1 26 26 255 213 208 0 0 0 0 0 37 126 59 29 10 79 152 0 138 179 0 28 32 0 0 0 0 0 37 126 82 16 165 219 40 1 26 26 255 213 208 0 0 0 0 0 37 126 59 58 90 211 216 0 192 205 0 28 32 0 0 0 0 0 37 126 63 17 77 74 112 0 220 209 0 28 32 0 0 0 0 0 37 126 82 16 171 120 168 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 177 184 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 169 171 184 1 26 26 255 213 208 0 0 0 0 0 37 126 74 16 94 78 192 1 27 194 255 213 208 0 0 0 0 0 37 126 63 38 173 219 0 0 160 31 0 28 32 0 0 0 0 0 37 126 82 16 167 211 16 1 26 26 255 213 208 0 0 0 0 0 37 126 69 19 206 1 224 0 221 171 255 213 208 0 0 0 0 0 37 126 68 4 230 34 152 0 198 213 255 213 208 0 0 0 0 0 37 126 62 25 194 53 48 0 215 241 0 28 32 0 0 0 0 0 37 126 60 15 46 164 120 0 210 35 0 28 32 0 0 0 0 0 37 126 68 52 235 163 80 0 198 79 255 213 208 0 0 0 0 0 37 126 82 7 152 35 56 0 197 226 255 213 208 0 0 0 0 0 37 126 59 9 113 115 48 0 143 254 0 28 32 0 0 0 0 0 37 126 69 49 186 178 152 1 3 22 255 213 208 0 0 0 0 0 37 126 69 41 103 66 40 0 189 221 255 213 208 0 0 0 0 0 37 126 68 4 12 116 8 0 197 131 255 213 208 0 0 0 0 0 37 126 82 16 188 26 120 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 179 64 216 1 26 26 255 213 208 0 0 0 0 0 37 126 69 21 48 127 224 0 189 109 255 213 208 0 0 0 0 0 37 126 69 20 45 92 8 0 204 245 255 213 208 0 0 0 0 0 37 126 82 16 177 115 232 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 196 52 176 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 102 24 1 26 26 255 213 208 0 0 0 0 0 37 126 82 57 244 249 160 0 197 236 255 213 208 0 0 0 0 0 37 126 82 16 175 135 184 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 194 99 216 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 153 40 1 26 26 255 213 208 0 0 0 0 0 37 126 60 14 188 43 200 0 181 83 0 28 32 0 0 0 0 0 37 126 82 16 195 89 240 1 26 26 255 213 208 0 0 0 0 0 37 126 60 38 154 0 248 1 30 51 0 28 32 0 0 0 0 0 37 126 82 16 174 169 16 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 173 178 248 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 193 133 48 1 26 26 255 213 208 0 0 0 0 0 37 126 59 4 4 50 192 0 144 9 0 28 32 0 0 0 0 0 37 126 69 20 25 79 56 0 182 64 255 213 208 0 0 0 0 0 37 126 82 16 172 212 80 1 26 26 255 213 208 0 0 0 0 0 37 126 68 40 177 21 112 1 18 146 255 213 208 0 0 0 0 0 37 126 82 16 173 202 104 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 170 255 144 1 26 26 255 213 208 0 0 0 0 0 37 126 60 36 114 59 16 0 130 164 0 28 32 0 0 0 0 0 37 126 59 17 83 7 48 0 225 216 0 28 32 0 0 0 0 0 37 126 82 16 171 241 192 1 26 26 255 213 208 0 0 0 0 0 37 126 59 34 58 193 160 0 144 128 0 28 32 0 0 0 0 0 37 126 62 54 40 214 112 0 188 244 0 28 32 0 0 0 0 0 37 126 60 14 207 125 24 0 167 184 0 28 32 0 0 0 0 0 37 126 82 16 170 36 208 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 169 46 184 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 80 16 1 26 26 255 213 208 0 0 0 0 0 37 126 62 9 171 161 184 0 209 227 0 28 32 0 0 0 0 0 37 126 59 43 182 145 40 0 182 128 0 28 32 0 0 0 0 0 37 126 82 16 169 70 40 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 167 19 168 1 26 26 255 213 208 0 0 0 0 0 37 126 62 1 181 225 168 0 113 223 0 28 32 0 0 0 0 0 37 126 60 11 122 223 144 0 181 101 0 28 32 0 0 0 0 0 37 126 62 15 156 184 40 1 27 28 0 28 32 0 0 0 0 0 37 126 82 57 140 209 144 0 197 134 255 213 208 0 0 0 0 0 37 126 82 16 166 154 144 1 26 26 255 213 208 0 0 0 0 0 37 126 59 33 195 59 248 0 164 172 0 28 32 0 0 0 0 0 37 126 13 0 0 0 0 0 180 215 0 14 16 0 0 0 0 0 37 126 82 16 179 189 216 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 187 184 208 1 26 26 255 213 208 0 0 0 0 0 37 126 69 24 175 238 88 0 218 31 255 213 208 0 0 0 0 0 37 126 68 50 56 86 168 0 201 107 255 213 208 0 0 0 0 0 37 126 72 43 26 10 216 0 247 225 0 28 32 0 0 0 0 0 37 126 82 16 196 177 176 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 227 24 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 177 237 0 1 26 26 255 213 208 0 0 0 0 0 37 126 62 12 245 82 96 0 113 163 0 28 32 0 0 0 0 0 37 126 82 16 177 18 64 1 26 26 255 213 208 0 0 0 0 0 37 126 62 3 173 143 16 0 211 85 0 28 32 0 0 0 0 0 37 126 69 20 164 206 40 0 212 74 255 213 208 0 0 0 0 0 37 126 82 16 195 214 240 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 175 38 16 1 26 26 255 213 208 0 0 0 0 0 37 126 68 18 77 225 240 1 51 66 255 213 208 0 0 0 0 0 37 126 82 16 194 2 48 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 51 152 1 26 26 255 213 208 0 0 0 0 0 37 126 60 40 98 163 104 0 239 204 0 28 32 0 0 0 0 0 37 126 82 16 194 248 72 1 26 26 255 213 208 0 0 0 0 0 37 126 78 44 110 2 24 1 25 144 0 28 32 0 0 0 0 0 37 126 68 26 232 250 32 1 37 78 255 213 208 0 0 0 0 0 37 126 82 16 174 71 104 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 184 253 152 1 26 26 255 213 208 0 0 0 0 0 37 126 63 55 154 189 192 0 220 225 0 28 32 0 0 0 0 0 37 126 82 16 173 77 104 1 26 26 255 213 208 0 0 0 0 0 37 126 59 18 72 232 128 0 205 105 0 28 32 0 0 0 0 0 37 126 82 16 172 110 192 1 26 26 255 213 208 0 0 0 0 0 37 126 59 43 216 105 56 0 170 191 0 28 32 0 0 0 0 0 37 126 59 14 224 206 176 0 179 56 0 28 32 0 0 0 0 0 37 126 82 16 170 157 232 1 26 26 255 213 208 0 0 0 0 0 37 126 59 48 51 32 104 0 131 7 0 28 32 0 0 0 0 0 37 126 69 48 113 43 56 1 46 1 255 213 208 0 0 0 0 0 37 126 82 16 171 144 24 1 26 26 255 213 208 0 0 0 0 0 37 126 59 18 220 98 104 0 142 140 0 28 32 0 0 0 0 0 37 126 75 57 28 57 88 1 12 30 0 28 32 0 0 0 0 0 37 126 82 16 169 195 40 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 205 16 1 26 26 255 213 208 0 0 0 0 0 37 126 59 17 139 139 240 0 130 231 0 28 32 0 0 0 0 0 37 126 62 3 246 64 112 1 25 9 0 28 32 0 0 0 0 0 37 126 82 16 186 143 240 1 26 26 255 213 208 0 0 0 0 0 37 126 59 27 190 52 16 0 171 106 0 28 32 0 0 0 0 0 37 126 82 16 167 238 104 1 26 26 255 213 208 0 0 0 0 0 37 126 59 6 109 98 192 0 125 90 0 28 32 0 0 0 0 0 37 126 57 52 14 153 96 0 227 130 255 157 144 0 0 0 0 0 37 126 62 47 46 176 136 0 209 104 0 28 32 0 0 0 0 0 37 126 81 48 217 16 224 0 244 55 255 213 208 0 0 0 0 0 37 126 69 8 21 230 136 1 34 94 255 213 208 0 0 0 0 0 37 126 59 51 234 213 32 0 146 132 0 28 32 0 0 0 0 0 37 126 62 28 99 214 104 0 210 247 0 28 32 0 0 0 0 0 37 126 60 35 58 13 24 0 180 193 0 28 32 0 0 0 0 0 37 126 82 16 187 48 24 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 188 53 208 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 179 92 48 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 166 244 104 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 187 83 64 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 177 139 88 1 26 26 255 213 208 0 0 0 0 0 37 126 11 0 0 0 0 1 19 6 0 14 16 0 0 0 0 0 37 126 82 51 85 5 144 0 197 174 255 213 208 0 0 0 0 0 37 126 82 16 196 80 8 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 129 112 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 175 174 200 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 194 127 48 1 26 26 255 213 208 0 0 0 0 0 37 126 79 36 40 100 184 0 164 47 0 28 32 0 0 0 0 0 37 126 68 41 58 31 120 1 47 28 255 213 208 0 0 0 0 0 37 126 82 16 195 113 96 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 176 152 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 174 196 104 1 26 26 255 213 208 0 0 0 0 0 37 126 68 32 8 151 144 0 209 109 255 213 208 0 0 0 0 0 37 126 82 16 193 160 136 1 26 26 255 213 208 0 0 0 0 0 37 126 82 20 64 91 80 0 198 124 255 213 208 0 0 0 0 0 37 126 82 16 172 235 192 1 26 26 255 213 208 0 0 0 0 0 37 126 62 9 199 235 232 1 51 166 0 28 32 0 0 0 0 0 37 126 82 16 173 229 192 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 171 26 232 1 26 26 255 213 208 0 0 0 0 0 37 126 68 17 101 168 184 1 55 157 255 213 208 0 0 0 0 0 37 126 82 16 172 13 24 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 170 60 64 1 26 26 255 213 208 0 0 0 0 0 37 126 62 59 125 153 88 1 32 234 0 28 32 0 0 0 0 0 37 126 62 21 198 13 8 0 209 142 0 28 32 0 0 0 0 0 37 126 59 15 164 22 224 0 135 163 0 28 32 0 0 0 0 0 37 126 82 16 168 107 104 1 26 26 255 213 208 0 0 0 0 0 37 126 59 43 158 89 240 0 142 76 0 28 32 0 0 0 0 0 37 126 82 16 169 97 128 1 26 26 255 213 208 0 0 0 0 0 37 126 62 37 222 171 240 1 53 59 0 28 32 0 0 0 0 0 37 126 59 38 70 227 160 0 144 158 0 28 32 0 0 0 0 0 37 126 59 42 215 26 32 0 129 208 0 28 32 0 0 0 0 0 37 126 59 4 138 51 112 0 129 215 0 28 32 0 0 0 0 0 37 126 69 38 108 241 208 0 182 121 255 213 208 0 0 0 0 0 37 126 70 17 226 129 168 0 245 96 255 213 208 0 0 0 0 0 37 126 62 59 107 116 208 0 113 219 0 28 32 0 0 0 0 0 37 126 62 53 51 227 104 1 40 253 0 28 32 0 0 0 0 0 37 126 79 44 211 243 192 0 157 23 0 28 32 0 0 0 0 0 37 126 63 42 16 79 128 0 160 6 0 28 32 0 0 0 0 0 37 126 69 39 24 213 184 0 224 60 255 213 208 0 0 0 0 0 37 126 62 20 90 95 120 1 53 77 0 28 32 0 0 0 0 0 37 126 59 23 219 193 240 0 192 200 0 28 32 0 0 0 0 0 37 126 82 16 179 213 72 1 26 26 255 213 208 0 0 0 0 0 37 126 82 13 92 93 72 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 187 208 64 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 8 88 1 26 26 255 213 208 0 0 0 0 0 37 126 69 57 209 229 40 0 203 141 255 213 208 0 0 0 0 0 37 126 82 16 196 201 32 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 250 136 1 26 26 255 213 208 0 0 0 0 0 37 126 59 34 218 233 160 1 49 1 0 28 32 0 0 0 0 0 37 126 69 11 197 156 96 0 216 215 255 213 208 0 0 0 0 0 37 126 82 16 177 41 176 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 195 238 96 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 175 61 128 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 194 29 136 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 75 8 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 173 104 192 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 195 15 184 1 26 26 255 213 208 0 0 0 0 0 37 126 60 58 252 220 80 1 30 54 0 28 32 0 0 0 0 0 37 126 82 16 174 94 216 1 26 26 255 213 208 0 0 0 0 0 37 126 59 45 255 115 160 0 135 101 0 28 32 0 0 0 0 0 37 126 60 58 57 155 240 0 134 176 0 28 32 0 0 0 0 0 37 126 82 16 172 134 48 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 170 185 64 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 166 80 88 1 26 26 255 213 208 0 0 0 0 0 37 126 59 52 233 15 40 0 144 2 0 28 32 0 0 0 0 0 37 126 82 16 171 167 136 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 228 128 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 166 213 40 1 26 26 255 213 208 0 0 0 0 0 37 126 69 17 68 34 176 1 3 75 255 213 208 0 0 0 0 0 37 126 82 16 169 218 152 1 26 26 255 213 208 0 0 0 0 0 37 126 60 4 109 186 96 0 134 49 0 28 32 0 0 0 0 0 37 126 62 39 147 202 72 0 210 197 0 28 32 0 0 0 0 0 37 126 62 41 215 179 80 1 25 222 0 28 32 0 0 0 0 0 37 126 62 12 23 234 176 0 213 27 0 28 32 0 0 0 0 0 37 126 60 34 72 125 64 0 207 75 0 28 32 0 0 0 0 0 37 126 60 20 253 51 16 0 181 7 0 28 32 0 0 0 0 0 37 126 62 22 3 92 88 1 43 15 0 28 32 0 0 0 0 0 37 126 59 9 217 124 0 0 145 43 0 28 32 0 0 0 0 0 37 126 82 16 168 5 216 1 26 26 255 213 208 0 0 0 0 0 37 126 59 39 18 195 8 0 126 247 0 28 32 0 0 0 0 0 37 126 68 56 188 8 88 1 18 224 255 213 208 0 0 0 0 0 37 126 69 5 9 35 136 0 220 223 255 213 208 0 0 0 0 0 37 126 59 40 219 156 40 0 144 245 0 28 32 0 0 0 0 0 37 126 82 16 188 77 64 1 26 26 255 213 208 0 0 0 0 0 37 126 78 34 153 84 144 1 21 136 0 28 32 0 0 0 0 0 37 126 69 51 144 34 96 0 205 101 255 213 208 0 0 0 0 0 37 126 62 53 174 8 240 1 41 153 0 28 32 0 0 0 0 0 37 126 82 16 179 115 160 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 187 110 152 1 26 26 255 213 208 0 0 0 0 0 37 126 63 41 98 143 8 0 220 123 0 28 32 0 0 0 0 0 37 126 82 16 177 162 200 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 196 103 120 1 26 26 255 213 208 0 0 0 0 0 37 126 75 12 95 1 232 1 27 176 255 213 208 0 0 0 0 0 37 126 82 16 178 152 224 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 175 206 8 1 26 26 255 213 208 0 0 0 0 0 37 126 69 25 179 61 40 0 188 231 255 213 208 0 0 0 0 0 37 126 82 16 194 150 160 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 200 8 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 195 140 184 1 26 26 255 213 208 0 0 0 0 0 37 126 59 41 165 170 184 0 216 26 0 28 32 0 0 0 0 0 37 126 82 16 174 219 216 1 26 26 255 213 208 0 0 0 0 0 37 126 59 33 72 165 40 0 205 65 0 28 32 0 0 0 0 0 37 126 82 16 193 183 248 1 26 26 255 213 208 0 0 0 0 0 37 126 59 41 215 183 56 0 142 170 0 28 32 0 0 0 0 0 37 126 82 16 173 3 48 1 26 26 255 213 208 0 0 0 0 0 37 126 59 49 29 214 88 0 204 16 0 28 32 0 0 0 0 0 37 126 59 10 27 1 112 0 142 202 0 28 32 0 0 0 0 0 37 126 82 16 173 253 48 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 171 50 88 1 26 26 255 213 208 0 0 0 0 0 37 126 59 38 234 1 112 0 137 14 0 28 32 0 0 0 0 0 37 126 59 47 154 87 32 0 137 10 0 28 32 0 0 0 0 0 37 126 82 16 172 36 136 1 26 26 255 213 208 0 0 0 0 0 37 126 61 22 145 205 48 0 183 1 0 28 32 0 0 0 0 0 37 126 82 16 164 131 104 1 26 26 255 213 208 0 0 0 0 0 37 126 63 55 70 252 88 0 219 253 0 28 32 0 0 0 0 0 37 126 63 44 60 161 120 0 220 222 0 28 32 0 0 0 0 0 37 126 82 16 170 83 176 1 26 26 255 213 208 0 0 0 0 0 37 126 60 48 28 158 176 1 14 193 0 28 32 0 0 0 0 0 37 126 79 2 10 12 136 0 181 42 0 28 32 0 0 0 0 0 37 126 82 40 23 58 184 0 197 51 255 213 208 0 0 0 0 0 37 126 68 52 244 113 56 0 201 215 255 213 208 0 0 0 0 0 37 126 60 32 199 251 168 0 239 98 0 28 32 0 0 0 0 0 37 126 59 28 233 8 16 0 143 96 0 28 32 0 0 0 0 0 37 126 82 16 169 120 240 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 130 216 1 26 26 255 213 208 0 0 0 0 0 37 126 59 24 226 155 0 0 142 85 0 28 32 0 0 0 0 0 37 126 70 56 87 172 240 0 177 31 255 213 208 0 0 0 0 0 37 126 60 8 106 181 120 0 179 232 0 28 32 0 0 0 0 0 37 126 63 31 82 44 88 0 223 179 0 28 32 0 0 0 0 0 37 126 62 36 132 115 32 0 189 7 0 28 32 0 0 0 0 0 37 126 82 16 166 181 232 1 26 26 255 213 208 0 0 0 0 0 37 126 59 48 142 224 176 0 125 254 0 28 32 0 0 0 0 0 37 126 82 16 187 235 152 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 31 200 1 26 26 255 213 208 0 0 0 0 0 37 126 59 43 245 192 240 0 192 189 0 28 32 0 0 0 0 0 37 126 82 16 196 228 120 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 179 17 248 1 26 26 255 213 208 0 0 0 0 0 37 126 59 41 158 154 32 0 192 243 0 28 32 0 0 0 0 0 37 126 82 16 177 65 32 1 26 26 255 213 208 0 0 0 0 0 37 126 63 50 240 209 56 0 117 216 0 28 32 0 0 0 0 0 37 126 82 16 196 5 208 1 26 26 255 213 208 0 0 0 0 0 37 126 59 30 178 141 16 0 140 142 0 28 32 0 0 0 0 0 37 126 82 16 175 84 240 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 194 52 248 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 98 120 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 173 128 48 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 195 43 16 1 26 26 255 213 208 0 0 0 0 0 37 126 59 59 33 131 32 0 146 142 0 28 32 0 0 0 0 0 37 126 82 16 174 122 48 1 26 26 255 213 208 0 0 0 0 0 37 126 68 32 63 220 0 1 37 62 255 213 208 0 0 0 0 0 37 126 62 43 219 44 64 1 41 5 0 28 32 0 0 0 0 0 37 126 82 16 172 161 136 1 26 26 255 213 208 0 0 0 0 0 37 126 59 52 121 93 104 0 186 97 0 28 32 0 0 0 0 0 37 126 62 38 121 132 144 0 114 50 0 28 32 0 0 0 0 0 37 126 60 33 199 35 248 0 210 39 0 28 32 0 0 0 0 0 37 126 82 16 170 208 176 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 171 190 248 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 251 240 1 26 26 255 213 208 0 0 0 0 0 37 126 60 16 51 164 224 0 180 184 0 28 32 0 0 0 0 0 37 126 59 30 102 93 40 0 135 28 0 28 32 0 0 0 0 0 37 126 82 16 169 245 240 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 168 33 48 1 26 26 255 213 208 0 0 0 0 0 37 126 59 50 131 179 160 0 130 249 0 28 32 0 0 0 0 0 37 126 61 12 154 226 8 0 181 180 0 28 32 0 0 0 0 0 37 126 60 18 165 127 160 0 129 194 0 28 32 0 0 0 0 0 37 126 62 14 50 78 208 0 215 49 0 28 32 0 0 0 0 0 37 126 60 50 110 161 24 0 117 171 0 28 32 0 0 0 0 0 37 126 82 16 188 100 176 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 179 139 16 1 26 26 255 213 208 0 0 0 0 0 37 126 13 0 0 0 0 0 180 180 0 14 16 0 0 0 0 0 37 126 82 16 187 137 240 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 177 190 32 1 26 26 255 213 208 0 0 0 0 0 37 126 69 39 175 73 88 1 4 91 255 213 208 0 0 0 0 0 37 126 82 16 196 126 232 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 178 176 80 1 26 26 255 213 208 0 0 0 0 0 37 126 69 4 1 68 192 0 223 114 255 213 208 0 0 0 0 0 37 126 68 43 227 160 80 0 209 225 255 213 208 0 0 0 0 0 37 126 82 16 194 174 16 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 176 223 120 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 175 233 96 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 195 164 40 1 26 26 255 213 208 0 0 0 0 0 37 126 62 22 40 139 224 1 25 2 0 28 32 0 0 0 0 0 37 126 82 16 174 243 72 1 26 26 255 213 208 0 0 0 0 0 37 126 59 7 17 235 216 0 184 56 0 28 32 0 0 0 0 0 37 126 82 16 193 211 80 1 26 26 255 213 208 0 0 0 0 0 37 126 59 51 78 133 128 0 144 143 0 28 32 0 0 0 0 0 37 126 82 16 173 30 136 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 194 197 128 1 26 26 255 213 208 0 0 0 0 0 37 126 60 41 93 5 16 0 245 181 0 28 32 0 0 0 0 0 37 126 82 16 174 20 160 1 26 26 255 213 208 0 0 0 0 0 37 126 82 16 171 73 200 1 26 26 255 213 208 0 0 0 0 0 37 126 63 21 240 42 72 0 159 123 0 28 32 0 0 0 0 0 37 126 82 16 172 59 248 1 26 26 255 213 208 0 0 0 0 0 37 126 62 52 221 196 136 0 189 108 0 28 32 0 0 0 0 0 37 126 62 15 4 158 168 1 38 105 0 28 32 0 0 0 0 22 70 76 72 111 111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 1 0 1 22 70 76 72 111 111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 1 0 4 23 70 76 86 97 114 105 97 98 108 101 79 98 106 101 99 116 67 108 117 115 116 101 114 0 0 0 211 0 5 0 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 5 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 43 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 21 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 5 0 0 0 6 0 0 0 156 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 8 0 24 1 148 2 15 0 139 0 10 0 8 0 21 1 34 2 15 1 252 0 10 0 8 0 25 0 129 0 109 0 253 0 10 0 8 0 56 1 152 2 15 0 209 0 10 0 8 0 72 1 76 0 63 0 145 0 10 0 6 0 72 0 32 1 124 0 10 0 6 0 108 0 93 1 156 0 10 0 8 0 43 0 246 2 15 0 191 0 10 0 8 0 25 1 244 0 81 0 230 2 14 0 8 0 25 1 19 0 81 1 143 2 14 0 8 0 25 0 118 0 113 1 247 0 10 0 8 0 71 1 108 2 15 0 141 0 10 0 8 0 103 1 101 2 15 1 7 0 10 0 8 0 42 0 204 2 15 1 70 0 10 0 8 0 94 1 145 2 15 0 248 0 10 0 8 0 24 0 182 2 15 0 147 0 10 0 8 0 21 0 169 2 15 2 6 0 10 0 8 0 77 1 154 2 15 0 172 0 10 0 8 0 56 1 67 2 15 0 217 0 10 0 8 0 43 1 132 2 15 0 203 0 10 0 8 0 60 1 54 0 45 1 194 0 10 0 8 0 103 1 200 2 15 1 11 0 10 0 8 0 18 1 214 2 15 1 74 0 10 0 8 0 94 1 135 2 15 0 254 0 10 0 8 0 24 1 240 2 15 0 239 0 10 0 8 0 21 1 94 2 15 0 202 0 10 0 8 0 56 1 222 2 15 1 52 0 10 0 8 0 77 0 152 2 15 1 17 0 10 0 8 0 58 0 205 2 15 1 36 0 10 0 8 0 13 0 151 0 73 0 135 0 10 0 8 0 103 1 53 2 15 1 102 0 10 0 8 0 76 2 10 2 15 1 163 0 10 0 8 0 92 1 5 2 15 1 92 0 10 0 8 0 35 0 225 2 15 1 79 0 10 0 8 0 16 0 251 2 15 1 38 0 10 0 8 0 46 1 10 2 15 1 140 0 10 0 8 0 42 1 91 2 15 1 116 0 10 0 8 0 114 1 193 0 98 1 16 0 10 0 8 0 58 0 156 2 15 1 129 0 10 0 8 0 77 0 181 2 15 1 205 0 10 0 8 0 103 1 178 2 15 1 198 0 10 0 8 0 76 1 112 2 15 1 245 0 10 0 8 0 92 0 162 2 15 1 182 0 10 0 8 0 57 2 0 2 15 1 168 0 10 0 8 0 16 1 107 2 15 1 131 0 10 0 8 0 53 1 159 0 34 1 77 0 10 0 8 0 46 2 2 2 15 1 231 0 10 0 8 0 58 0 200 2 15 1 219 0 10 0 8 0 103 1 181 2 15 0 123 0 10 0 8 0 106 0 171 2 15 1 142 0 10 0 8 0 76 0 221 2 15 0 185 0 10 0 8 0 65 1 202 2 15 2 8 0 10 0 8 0 36 1 111 0 84 0 190 0 10 0 8 0 57 1 58 2 15 1 249 0 10 0 8 0 20 1 170 2 15 1 221 0 10 0 8 0 46 0 143 2 15 0 166 0 10 0 8 0 89 1 238 2 15 0 155 0 10 0 8 0 103 0 229 2 15 0 219 0 10 0 8 0 106 0 198 2 15 1 73 0 10 0 8 0 101 0 178 2 15 1 21 0 10 0 8 0 13 1 82 0 19 0 228 0 10 0 8 0 65 0 160 2 15 0 206 0 10 0 8 0 57 1 147 2 15 0 189 0 10 0 8 0 20 0 235 2 15 0 153 0 10 0 8 0 22 1 227 2 15 1 2 0 10 0 8 0 89 1 187 2 15 0 243 0 10 0 8 0 54 1 39 0 85 0 240 0 10 0 8 0 103 1 139 2 15 1 55 0 10 0 8 0 28 1 189 2 15 1 118 0 10 0 8 0 65 1 233 2 15 1 41 0 10 0 8 0 106 1 105 2 15 1 12 0 10 0 8 0 112 1 15 2 15 1 26 0 10 0 8 0 20 0 231 2 15 0 245 0 10 0 8 0 111 0 154 2 15 1 242 0 10 0 8 0 55 1 209 2 15 1 95 0 10 0 8 0 69 0 126 2 15 1 85 0 10 0 8 0 64 0 180 0 62 1 89 0 10 0 8 0 103 0 250 2 15 1 144 0 10 0 8 0 28 1 164 2 15 1 207 0 10 0 8 0 65 1 69 2 15 1 133 0 10 0 8 0 112 0 134 2 15 1 122 0 10 0 8 0 48 0 201 2 15 1 84 0 10 0 8 0 106 1 106 2 15 0 196 0 10 0 8 0 55 1 115 2 15 1 186 0 10 0 8 0 77 0 152 0 104 1 167 0 10 0 8 0 105 1 24 0 33 1 117 0 10 0 2 0 75 0 17 1 65 0 10 2 120 2 129 2 138 2 147 2 155 2 163 2 172 2 180 2 189 2 196 2 203 2 211 2 219 2 17 2 32 2 41 2 50 2 60 2 70 2 79 2 88 2 97 2 108 2 116 2 125 2 134 2 142 2 151 2 159 2 168 2 176 2 185 2 192 2 199 2 207 2 215 2 222 2 27 0 8 0 70 1 228 2 15 1 172 0 10 0 8 0 103 1 3 2 15 1 235 0 10 0 8 0 28 0 216 2 15 0 138 0 10 0 8 0 65 1 150 2 15 1 223 0 10 0 8 0 15 0 177 2 15 1 211 0 10 0 8 0 61 1 120 2 15 1 173 0 10 0 8 0 106 1 57 2 15 0 128 0 10 0 8 0 55 0 215 2 15 2 11 0 10 0 8 0 44 1 4 2 15 1 253 0 10 0 8 0 103 2 4 2 15 0 170 0 10 0 8 0 28 1 190 2 15 0 233 0 10 0 8 0 65 0 125 2 15 0 159 0 10 0 8 0 49 1 97 2 15 0 142 0 10 0 8 0 61 0 236 2 15 1 255 0 10 0 8 0 106 1 237 2 15 0 222 0 10 0 8 0 47 1 212 2 15 0 208 0 10 0 8 0 44 1 204 2 15 0 193 0 10 0 8 0 67 0 232 2 15 0 157 0 10 0 8 0 103 1 104 2 15 1 6 0 10 0 8 0 28 1 43 2 15 1 71 0 10 0 8 0 65 0 244 2 15 0 247 0 10 0 8 0 99 0 140 2 15 0 234 0 10 0 8 0 61 1 160 2 15 0 195 0 10 0 8 0 115 0 194 2 15 1 61 0 10 0 8 0 47 0 210 2 15 1 46 0 10 0 8 0 44 2 12 2 15 1 29 0 10 0 8 0 67 0 227 2 15 0 249 0 10 0 8 0 23 1 197 2 15 1 96 0 10 0 8 0 28 1 203 2 15 1 158 0 10 0 8 0 65 1 14 2 15 1 86 0 10 0 8 0 40 2 13 2 15 1 72 0 10 0 8 0 61 0 131 2 15 1 32 0 10 0 8 0 115 1 234 2 15 1 153 0 10 0 8 0 88 0 127 2 15 1 136 0 10 0 8 0 31 0 133 2 15 1 125 0 10 0 8 0 67 0 224 2 15 1 88 0 10 0 8 0 86 0 121 2 15 1 191 0 10 0 8 0 26 1 149 2 15 1 175 0 10 0 8 0 40 1 110 2 15 1 162 0 10 0 8 0 27 0 148 2 15 1 126 0 10 0 8 0 115 0 132 2 15 1 236 0 10 0 8 0 42 1 103 2 15 1 42 0 10 0 8 0 88 1 180 2 15 1 226 0 10 0 8 0 31 1 64 2 15 1 213 0 10 0 8 0 30 1 23 2 15 1 177 0 10 0 8 0 56 1 157 2 15 0 117 0 10 0 8 0 26 0 164 2 15 2 1 0 10 0 8 0 40 1 225 2 15 1 243 0 10 0 8 0 27 1 31 2 15 1 215 0 10 0 8 0 115 1 134 2 15 0 176 0 10 0 8 0 88 1 176 2 15 0 163 0 10 0 8 0 31 1 98 2 15 0 144 0 10 0 8 0 30 1 195 2 15 2 3 0 10 0 8 0 56 1 152 2 15 0 212 0 10 0 8 0 26 0 226 2 15 0 197 0 10 0 8 0 40 1 161 2 15 0 183 0 10 0 8 0 74 1 22 2 15 0 146 0 10 0 8 0 14 1 50 2 15 1 8 0 10 0 8 0 50 1 45 2 15 0 252 0 10 0 8 0 31 1 9 2 15 0 237 0 10 0 8 0 66 1 87 2 15 0 199 0 10 2 18 2 20 2 21 2 22 2 175 2 24 2 25 2 26 2 182 2 184 2 100 2 102 2 36 2 45 2 53 2 61 2 68 2 76 2 82 2 92 2 101 0 8 0 56 1 67 2 15 1 49 0 10 0 8 0 26 1 229 2 15 1 33 0 10 0 8 0 40 1 151 2 15 1 20 0 10 0 8 0 52 1 250 2 15 0 238 0 10 0 8 0 14 0 211 2 15 1 100 0 10 0 8 0 79 1 174 2 15 1 90 0 10 0 8 0 31 1 146 2 15 1 75 0 10 0 8 0 11 1 251 2 15 1 35 0 10 0 8 0 56 1 222 2 15 1 137 0 10 0 8 0 96 1 196 2 15 1 127 0 10 0 8 0 38 1 63 0 110 0 223 0 10 0 8 0 52 1 113 2 15 1 78 0 10 0 8 0 14 1 99 2 15 1 199 0 10 0 8 0 51 1 1 2 15 1 179 0 10 0 8 0 31 1 68 2 15 1 165 0 10 0 8 0 97 0 165 2 15 1 128 0 10 0 8 0 56 1 18 2 15 1 230 0 10 0 6 0 78 0 95 0 187 0 10 0 8 0 96 0 137 2 15 1 217 0 10 0 2 0 59 0 87 0 220 0 10 2 205 2 214 2 226 2 33 2 43 2 55 2 65 2 74 2 86 2 98 2 109 2 117 2 126 2 135 2 143 2 152 2 160 2 169 2 177 2 186 2 193 2 200 2 208 2 216 2 223 2 28 2 37 2 46 2 56 2 64 2 73 2 83 2 93 2 104 2 112 2 121 2 130 2 139 2 148 2 156 2 165 2 173 2 181 2 190 2 197 2 204 2 212 2 220 2 19 2 34 2 42 2 51 2 62 2 71 2 80 2 90 2 99 2 110 2 118 2 127 2 136 2 145 2 153 2 161 2 170 2 178 2 187 2 194 2 201 2 209 2 217 2 225 2 30 2 39 2 48 2 58 2 67 2 77 2 85 2 95 2 106 2 114 2 123 2 132 2 140 2 149 2 157 2 166 2 174 2 183 2 191 2 198 2 206 2 213 2 221 2 23 2 35 2 44 2 54 2 63 2 72 2 81 2 91 2 103 2 111 2 119 2 128 2 137 2 146 2 154 2 162 2 171 2 179 2 188 2 195 2 202 2 210 2 218 2 16 2 31 2 40 2 49 2 59 2 69 2 78 2 87 2 96 2 107 2 115 2 124 2 133 2 141 2 150 2 158 2 167 2 52 2 144 2 224 2 29 2 38 2 47 2 57 2 66 2 75 2 84 2 94 2 105 2 113 2 122 2 131 2 89 0 8 0 100 0 174 2 15 1 166 0 10 0 8 0 41 0 175 2 15 0 122 0 10 0 8 0 116 1 123 2 15 2 5 0 10 0 8 0 31 1 30 2 15 1 246 0 10 0 8 0 12 1 155 2 15 1 218 0 10 0 8 0 107 1 60 2 15 0 167 0 10 0 8 0 96 1 37 2 15 0 149 0 10 0 8 0 39 1 66 2 15 1 248 0 10 0 8 0 41 1 185 2 15 0 218 0 10 0 8 0 80 1 241 2 15 0 207 0 10 0 8 0 24 1 28 2 15 0 186 0 10 0 8 0 83 1 224 2 15 0 150 0 10 0 8 0 29 1 47 2 15 0 255 0 10 0 8 0 96 0 120 2 15 0 241 0 10 0 8 0 90 1 51 2 15 0 188 0 10 0 8 0 41 1 184 2 15 1 56 0 10 0 8 0 80 0 124 2 15 1 44 0 10 0 8 0 24 1 109 2 15 1 27 0 10 0 8 0 83 1 40 2 15 0 242 0 10 0 8 0 29 1 48 2 15 1 93 0 10 0 8 0 77 1 62 2 15 1 188 0 10 0 8 0 96 0 158 2 15 1 80 0 10 0 8 0 68 0 119 2 15 1 25 0 10 0 8 0 41 0 213 2 15 1 141 0 10 0 8 0 91 1 239 2 15 1 130 0 10 0 8 0 24 1 13 2 15 1 119 0 10 0 8 0 83 0 130 2 15 1 81 0 10 0 8 0 29 1 47 2 15 1 183 0 10 0 8 0 82 2 7 2 15 1 169 0 10 0 8 0 77 1 206 2 15 0 214 0 10 0 8 0 68 0 184 2 15 1 121 0 10 0 8 0 103 1 216 2 15 1 232 0 10 0 8 0 91 1 0 2 15 1 220 0 10 0 8 0 24 0 136 2 15 1 208 0 10 0 8 0 102 1 83 2 15 1 171 0 10 0 8 0 56 1 157 2 15 2 9 0 10 0 8 0 37 1 192 2 15 1 254 0 10 0 8 0 68 1 201 2 15 1 210 0 10 0 8 0 103 0 192 2 15 0 168 0 10 0 8 0 42 1 114 2 15 1 59 0 10 0 8 0 94 0 179 2 15 0 161 0 10 0 8 0 77 0 173 2 15 1 138 0 10 2 164]! !

Object subclass: #GTADateAndTimeStringBuilder
	instanceVariableNames: 'dateAndTime duration numberOfLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
dateAndTime
	^ dateAndTime! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
dateAndTime: anObject
	dateAndTime := anObject! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
duration
	^ duration! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
duration: anObject
	duration := anObject! !

!GTADateAndTimeStringBuilder methodsFor: 'printing' stamp: 'JurajKubelka 5/18/2015 12:13'!
humanReadablePrintString
	self duration days > self numberOfLabels ifTrue: [ ^ self dateAndTime asDate printString ].
	self duration days > 1 ifTrue: [ ^ String streamContents: [ :aStream | 
			self dateAndTime printSeparateDateAndTimeOn: aStream ] ]. 
	^ self dateAndTime asTime print24! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:24'!
numberOfLabels
	^ numberOfLabels! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:24'!
numberOfLabels: anObject
	numberOfLabels := anObject! !

Object subclass: #GTADefaultTimelineConfiguration
	instanceVariableNames: 'lastBuilder withEdges layout shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

GTADefaultTimelineConfiguration class
	instanceVariableNames: 'uniqueInstance'!

GTADefaultTimelineConfiguration class
	instanceVariableNames: 'uniqueInstance'!

!GTADefaultTimelineConfiguration class methodsFor: 'cleanup' stamp: 'JurajKubelka 4/15/2015 16:10'!
cleanUp
	self reset.! !

!GTADefaultTimelineConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:09'!
reset
	"self reset"
	uniqueInstance := nil! !

!GTADefaultTimelineConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:52'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'api' stamp: 'JurajKubelka 4/17/2015 11:32'!
configure: builder 
	builder
		withEdges: self withEdges;
		layout: self layout.
	builder shape shape: self shape.
	builder interaction
		popupText: #asEventAnalysisString;
		draggable.
	builder interaction showEdge
		connectTo: [ :event | 
			event isUserSelection
				ifFalse: [ RTGroup new ]
				ifTrue: [ 
					builder view elements
						select: [ :eachElement | eachElement model isSpotterEvent
								and: [ eachElement model isUserSelection
								and: [ eachElement model elementName = event elementName ] ] ]
						thenCollect: #model ] ];
		shape: [ :el | RTLine new color: (Color blue alpha: 0.4) ] ! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:56'!
layout
	^ layout ifNil: [ layout := GTAHorizontalDivingLineLayout new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:04'!
layout: aLayout 
	layout := aLayout! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/19/2015 13:57'!
shape
	^ shape ifNil: [ shape := GTAOrthogonalIconBuilder new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:05'!
shape: aShape 
	shape := aShape! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/17/2015 14:32'!
withEdges
	^ withEdges ifNil: [ withEdges := false ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:05'!
withEdges: aBoolean 
	withEdges := aBoolean! !

Object subclass: #GTAEmptyBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTAEmptyBookmark subclass: #GTABookmark
	instanceVariableNames: 'item description dateAndTime garbage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTABookmark class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/20/2015 11:05'!
from: pathCollection computers: aGTAComputers 
	^ pathCollection first new from: pathCollection computers: aGTAComputers! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:30'!
dateAndTime
	^ dateAndTime! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:30'!
dateAndTime: anObject
	dateAndTime := anObject! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:25'!
description
	^ description! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:25'!
description: anObject
	description := anObject! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:13'!
garbage
	^ garbage! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:14'!
garbage: aBoolean
	garbage := aBoolean! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:14'!
garbageString
	^ self garbage
		ifTrue: 'yes'
		ifFalse: 'no'! !

!GTABookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 10:13'!
initialize
	super initialize.
	dateAndTime := DateAndTime now.
	garbage := false.! !

!GTABookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:59'!
isRelatedTo: anObject 
	^ self item = anObject ! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:29'!
item
	^ item! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:29'!
item: anObject
	item := anObject! !

!GTABookmark methodsFor: 'instance creation' stamp: 'JurajKubelka 5/19/2015 15:26'!
newDetachedBookmark: aPathCollection
	^ GTADetachedBookmark new
			path: aPathCollection;
			yourself! !

!GTABookmark methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 10:22'!
toggleGarbage
	self garbage: self garbage not! !

GTABookmark subclass: #GTAComputerBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTAComputerBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:26'!
from: aCollection computers: aGTAComputers 
	| computer |
	computer := aGTAComputers 
						detect: [ :each | each computerUUID = aCollection second ]
						ifNone: [ ^ self newDetachedBookmark: aCollection ].
	self
		item: computer;
		description: aCollection third;
		dateAndTime: aCollection fourth;
		garbage: aCollection fifth! !

!GTAComputerBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:54'!
path
	^ Array
		with: self class
		with: self item computerUUID
		with: self description
		with: self dateAndTime
		with: self garbage! !

!GTAComputerBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:05'!
typeName
	^ 'computer'! !

GTABookmark subclass: #GTASessionBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTASessionBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:22'!
from: aCollection computers: aGTAComputers 
	| computer session |
	computer := aGTAComputers 
						detect: [ :each | each computerUUID = aCollection second ] 
						ifNone: [ ^ self newDetachedBookmark: aCollection ].
	session := computer 
						detect: [ :each | each start = aCollection third ] 
						ifNone: [ ^ self newDetachedBookmark: aCollection ].
	self
		item: session;
		description: aCollection fourth;
		dateAndTime: aCollection fifth;
		garbage: aCollection sixth! !

!GTASessionBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:55'!
path
	^ Array
		with: self class
		with: self item computerUUID
		with: self item start
		with: self description
		with: self dateAndTime
		with: self garbage! !

!GTASessionBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:05'!
typeName
	^ 'session'! !

GTABookmark subclass: #GTASomeSessionsBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTASomeSessionsBookmark methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/20/2015 11:25'!
from: aCollection computers: aGTAComputers 
	| computer |
	self item: (GTASomeSessions new: aCollection size - 5).
	computer := aGTAComputers detect: [ :eachComputer | eachComputer computerUUID = (aCollection at: 2) ].
	self item computer: computer.
	self description: (aCollection at: 3).
	self dateAndTime: (aCollection at: 4).
	self garbage: (aCollection at: 5).
	6 to: aCollection size do: [ :index |
		self item add: (GTABookmark from: (aCollection at: index) computers: aGTAComputers) item ].
! !

!GTASomeSessionsBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 11:19'!
path
	| collection |
	collection := (Array new: self item size + 5).
	collection at: 1 put: self class.
	collection at: 2 put: self item computer computerUUID.
	collection at: 3 put: self description.
	collection at: 4 put: self dateAndTime.
	collection at: 5 put: self garbage.
	1 to: self item size do: [ :index |
		collection at: index + 5 put: (GTASessionBookmark new item: (self item at: index)) path.
	].
	^ collection! !

!GTASomeSessionsBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 10:10'!
typeName
	^ 'sessions'! !

GTAEmptyBookmark subclass: #GTADetachedBookmark
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:32'!
description
	^ String streamContents: [ :aStream |
		aStream 
			nextPutAll: 'Not found bookmark of ';
			print: self path
		 ]! !

!GTADetachedBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:24'!
from: aCollection computers: aGTAComputers 
	self shouldNotImplement ! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 11:30'!
garbageString
	^ ''! !

!GTADetachedBookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/19/2015 15:25'!
isRelatedTo: anObject
	^ false! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:32'!
item
	^ self path! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:23'!
path
	^ path! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:23'!
path: aPathCollection
	path := aPathCollection! !

!GTADetachedBookmark methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 15:24'!
toggleGarbage
	"do nothing"! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:23'!
typeName
	^ 'detached'! !

!GTAEmptyBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:19'!
from: aCollection computers: aGTAComputers 
	self subclassResponsibility! !

!GTAEmptyBookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/19/2015 15:18'!
isRelatedTo: anObject
	^ self subclassResponsibility! !

!GTAEmptyBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:19'!
path
	^ self subclassResponsibility.! !

!GTAEmptyBookmark methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 15:19'!
toggleGarbage
	self subclassResponsibility! !

!GTAEmptyBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:19'!
typeName
	^ self subclassResponsibility! !

Object subclass: #GTAIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHalfHeight
	^ 5! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHeight
	^ 10! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultMinHeight
	^ 2! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultMinWidth
	^ 1! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultWidth
	^ 10! !

!GTAIconBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/13/2015 17:00'!
elementOn: aModel 
	^ (self shapeFor: aModel) elementOn: aModel! !

!GTAIconBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/13/2015 16:58'!
elementsOn: models
	^ models collect: [ :eachModel | (self elementOn: eachModel) ] as: RTGroup! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/19/2015 13:35'!
newContextChangedForOneWordEvent: aGTSpotterEvent
	| shape sizes |
	shape := RTBox new height: self defaultHeight; width: self defaultMinWidth; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	(sizes notNil and: [ sizes notEmpty ]) ifTrue: [ shape width: sizes sum ].
	aGTSpotterEvent hasCurrentTextSpecials ifTrue: [ shape height: self defaultHalfHeight ]. 
	^ shape! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/19/2015 13:35'!
newContextChangedForSeveralWordsEvent: aGTSpotterEvent
	| composition sizes keywords shapes |
	composition := RTCompositeShape new horizontal; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	keywords := aGTSpotterEvent currentTextSpecials.
	shapes := OrderedCollection new.
	sizes with: keywords do: [ :size :keyword |
		shapes add: (self newShapeForWordOfSize: size keyword: keyword) ].
	shapes 
		do: [ :shape | composition add: shape ]
		separatedBy: [ 
			composition add: (RTBox new height: 1; width: 1; yourself) ].
	^ composition! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 11:40'!
newCorrectDiveInElementEvent: aGTSpotterEvent
	^ RTBox new
		height: 2;
		width: 5;
		yourself! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 11:45'!
newMissStepDiveInElementEvent: aGTSpotterEvent 
	| s1 s3 s2 c |
	c := RTCompositeShape new.
	s1 := RTBox new
				height: 2;
				width: 2;
				yourself.
	s2 := RTBox new
				height: 2;
				width: 1;
				color: Color transparent;
				yourself.
	s3 := RTBox new
				height: 2;
				width: 2;
				yourself.
	c add: s1; add: s2; add: s3; horizontal.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:33'!
newSearchFinishedForOneCategoryEvent: aGTSpotterEvent
	| size sizes shapeAndSize |
	sizes := aGTSpotterEvent items.
	(sizes notNil and: [ sizes notEmpty ]) 
		ifTrue: [ size := sizes sum ]
		ifFalse: [ size := 1 ].
	shapeAndSize := self newShapeForQueryOfSize: size.
	^ shapeAndSize key! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:32'!
newSearchFinishedForSeveralCategoriesEvent: aGTSpotterEvent
	| composition categoriesAndItems offset |
	composition := RTCompositeShape new.
	categoriesAndItems := aGTSpotterEvent notEmptyCategories.
	offset := 0.
	categoriesAndItems 
		do: [ :categoryAndItems | | shapeAndSize size |
			size := categoryAndItems value.
			shapeAndSize := self newShapeForQueryOfSize: size.
			composition add: shapeAndSize key translateBy: offset @ 0.
			offset := offset + shapeAndSize value ]
		separatedBy: [ | connector |
			connector := RTCompositeShape new.
			connector 
				add: (RTBox new height: 1; width: 1; yourself);
				add: (RTBox new height: 1; width: 1; yourself)
					translateBy: 0 @ 6.
			composition 
				add: connector
				translateBy: offset @ 0.
				offset := offset + 2 ].
	^ composition! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:31'!
newShapeForQueryOfSize: wordSize
	| s1 s3 c size |
	size := wordSize // 10.
	size < 2 ifTrue: [ size := 2 ].
	size > 100 ifTrue: [ size := 100 ].
	c := RTCompositeShape new.
	s1 := RTBox new height: 4; width: size; yourself.
	s3 := RTBox new height: 4; width: size; yourself.	
	c 
		add: s1;
		add: s3 translateBy: 0 @ 6.
	^ c -> size! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:41'!
newShapeForSelectionEventKeyArrowDown: aGTSpotterEvent 
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownDifferentCategory: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:48'!
newShapeForSelectionEventKeyArrowDownDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownDifferentCategoryUnique: aGTSpotterEvent  ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:58'!
newShapeForSelectionEventKeyArrowDownDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s2 translateBy: 0 @ 7; 
		add: s1 translateBy: 0 @ 12.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:36'!
newShapeForSelectionEventKeyArrowDownDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s1 translateBy: 0 @ 7; 
		add: s2 translateBy: 0 @ 12.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:36'!
newShapeForSelectionEventKeyArrowDownSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownSameCategoryUnique: aGTSpotterEvent  ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:08'!
newShapeForSelectionEventKeyArrowDownSameCategoryRepetition: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:11'!
newShapeForSelectionEventKeyArrowDownSameCategoryUnique: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:41'!
newShapeForSelectionEventKeyArrowUp: aGTSpotterEvent
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpDifferentCategory: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:53'!
newShapeForSelectionEventKeyArrowUpDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpDifferentCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:01'!
newShapeForSelectionEventKeyArrowUpDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1;
		add: s2 translateBy: 0 @ 5; 
		add: s3 translateBy: 0 @ 13.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:03'!
newShapeForSelectionEventKeyArrowUpDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1;
		add: s2 translateBy: 0 @ 5; 
		add: s3 translateBy: 0 @ 13.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:52'!
newShapeForSelectionEventKeyArrowUpSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpSameCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:30'!
newShapeForSelectionEventKeyArrowUpSameCategoryRepetition: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 9; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:03'!
newShapeForSelectionEventKeyArrowUpSameCategoryUnique: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 6; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:43'!
newShapeForSelectionEventSingleClick: aGTSpotterEvent 
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventSingleClickSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickDifferentCategory: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:59'!
newShapeForSelectionEventSingleClickDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventSingleClickDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickDifferentCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:50'!
newShapeForSelectionEventSingleClickDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 s4 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s3 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s4 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s4 translateBy: 0 @ 5; 
		add: s1 translateBy: 0 @ 10;
		add: s2 translateBy: 0 @ 15.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:47'!
newShapeForSelectionEventSingleClickDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 s4 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s3 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ -5. 5 @ 0 };
				yourself.
	s4 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ -5. 5 @ 0 };
				yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s4 translateBy: 0 @ 5; 
		add: s1 translateBy: 0 @ 10;
		add: s2 translateBy: 0 @ 15.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:56'!
newShapeForSelectionEventSingleClickSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventSingleClickSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickSameCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:55'!
newShapeForSelectionEventSingleClickSameCategoryRepetition: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0. 2 @ 5. -2 @ 5 };
			yourself! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:33'!
newShapeForSelectionEventSingleClickSameCategoryUnique: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			yourself! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 10:21'!
newShapeForWordOfSize: wordSize keyword: aBoolean
	^ RTBox new 
			height: (aBoolean ifTrue: [ self defaultHalfHeight ] ifFalse: [ self defaultHeight ]); 
			width: wordSize; 
			yourself.! !

!GTAIconBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 16:49'!
shapeFor: aGTSpotterEvent 
	^ aGTSpotterEvent accept: self! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitActOnEvent: aGTSpotterEvent 
	^ RTPolygon new vertices: { -5 @ -5. 5 @ 0. -5 @ 5 }; yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitCategorySelectedEvent: aGTSpotterRecorderCategorySelectedEvent 
	^ nil! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:35'!
visitContextChangedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent currentTextSizes size < 2
		ifTrue: [ self newContextChangedForOneWordEvent: aGTSpotterEvent ]
		ifFalse: [ self newContextChangedForSeveralWordsEvent: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 14:23'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTBox new height: 2; width: 5; yourself.
	s2 := RTBox new height: 2; width: 5; color: Color transparent; yourself.
	s3 := RTBox new height: 2; width: 5; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; add: s3; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/14/2015 11:40'!
visitDiveInElementEvent: aGTSpotterEvent 
	^ aGTSpotterEvent isMissStep 
		ifTrue: [ self newMissStepDiveInElementEvent: aGTSpotterEvent ]
		ifFalse: [ self newCorrectDiveInElementEvent: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 14:24'!
visitDiveOutEvent: aGTSpotterEvent 
	^ RTBox new
		height: 2;
		width: 5;
		yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitExitEvent: aGTSpotterEvent 
	^ RTPolygon new 
		vertices: { 
			-4 @ -5. 0 @ -1. 4 @ -5. 5 @ -4. 1 @ 0. 
			5 @ 4. 4 @ 5. 0 @ 1. -4 @ 5. -5 @ 4. -1 @ 0. -5 @ -4 };
		yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 01:38'!
visitHidePreviewEvent: aGTSpotterEvent 
	^ RTArc new 
			innerRadius: 4;
			externalRadius: 5;
			outerAngle: 0 innerAngle: 360! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitOpenEvent: aGTSpotterRecorderOpenEvent 
	^ nil! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:34'!
visitSearchFinishedEvent: aGTSpotterEvent 
	^ RTPolygon new
			vertices: { -5 @ 0. -3 @ 0. -1 @ 4. 1 @ -3. 3 @ 0. 5 @ 0. 
							5 @ -1. 3 @ -1. 1 @ -4. -1 @ 3. -3 @ -1. -5 @ -1 };
			yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 13:42'!
visitSelectedCandidateChangedEvent: aGTSpotterEvent 
	| type |
	type := aGTSpotterEvent eventType. 
	type = #keyPressedArrowUp ifTrue: [ 
		^ self newShapeForSelectionEventKeyArrowUp: aGTSpotterEvent ].

	type = #keyPressedArrowDown ifTrue: [ 
		^ self newShapeForSelectionEventKeyArrowDown: aGTSpotterEvent ].

	type = #singleClick ifTrue: [ 
		^ self newShapeForSelectionEventSingleClick: aGTSpotterEvent ].

	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			color: Color transparent;
			borderColor: RTPolygon new defaultColor;
			yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 00:21'!
visitShowPreviewEvent: aGTSpotterEvent 
	^ RTEllipse new size: 10; yourself! !

GTAIconBuilder subclass: #GTAOrthogonalIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

GTAOrthogonalIconBuilder subclass: #GTAFlexibleResultIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAFlexibleResultIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:58'!
visitSearchFinishedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent notEmptyCategories size < 2
		ifTrue: [ self newSearchFinishedForOneCategoryEvent: aGTSpotterEvent ]
		ifFalse: [ self newSearchFinishedForSeveralCategoriesEvent: aGTSpotterEvent ]! !

!GTAOrthogonalIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 12:24'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -3 @ -2. 1 @ -2. 1 @ 4. 3 @ 4. 3 @ 5. 0 @ 5. 0 @ 1. 
								-3 @ 1. -3 @ 0. 0 @ 0. 0 @ -1. -3 @ -1 };
				yourself.
	s2 := RTBox new width: 6; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAOrthogonalIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 12:26'!
visitDiveInElementEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -2 @ -1. 1 @ -1. 1 @ 4. 3 @ 4. 3 @ 5. 0 @ 5. 0 @ 0. -2 @ 0 };
				yourself.
	s2 := RTBox new width: 5; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAOrthogonalIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 14:39'!
visitDiveOutEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -2 @ 1. 1 @ 1. 1 @ -4. 3 @ -4. 3 @ -5. 0 @ -5. 0 @ 0. -2 @ 0 };
				yourself.
	s2 := RTBox new width: 5; height: 5; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1; 
		add: s2 translateBy: 0 @ 7.
	^ c! !

Object subclass: #GTAMenuBuilder
	instanceVariableNames: 'timelineBuilder menuBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 16:11'!
addEdges
	timelineBuilder withEdges; addEdges; signalUpdate.
	self configuration withEdges: timelineBuilder isWithEdges.! !

!GTAMenuBuilder methodsFor: 'building' stamp: 'JurajKubelka 4/14/2015 14:32'!
build
	self renderIn: timelineBuilder view.! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 15:07'!
colorMostOftenQueriesAndItemsInComputer
	| els bag hashes counts normalizer computers |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	computers := els collect: [ :e | e model session computer ] as: Set.
	bag := (computers flatCollect: [ :e | e userQueryOrSelectionHashes collect: #hash ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:38'!
colorMostOftenQueriesAndItemsInView
	| els bag hashes counts normalizer |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	bag := (els flatCollect: [ :e | e model userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:49'!
colorSameQueriesAndItemsInComputer
	| els bag hashes counts normalizer computers |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	computers := els collect: [ :e | e model session computer ] as: Set.
	bag := (computers flatCollect: [ :e | e userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:38'!
colorSameQueriesAndItemsInView
	| els bag hashes counts normalizer |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	bag := (els flatCollect: [ :e | e model userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:03'!
configuration
	^ GTADefaultTimelineConfiguration uniqueInstance! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	timelineBuilder shape flexibleResultShapes.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAMenuBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 4/14/2015 14:32'!
initialize
	super initialize.
	menuBuilder := RTMenuBuilder new.! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:01'!
logicalTimeline
	timelineBuilder
			logicalLayout;
			layoutElements;
			signalUpdate.
	self configuration 
			layout: timelineBuilder layout! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/16/2015 15:16'!
obliqueShapes
	timelineBuilder shape oblique.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/16/2015 15:16'!
orthogonalShapes
	timelineBuilder shape orthogonal.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:01'!
realTimeline
	timelineBuilder
			realLayout;
			layoutElements;
			signalUpdate.
	self configuration 
		layout: timelineBuilder layout! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:04'!
removeEdges
	timelineBuilder withoutEdges; removeEdges; signalUpdate.
	self configuration withEdges: timelineBuilder isWithEdges.! !

!GTAMenuBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/20/2015 14:38'!
renderIn: aView
	menuBuilder view: aView.
	menuBuilder menu: 'Layout' submenu: 'Logical Timeline' callback: [ self logicalTimeline ].
	menuBuilder menu: 'Layout' submenu: 'Real Timeline' callback: [ self realTimeline ].
	menuBuilder menu: 'Edges' submenu: 'Remove' callback: [ self removeEdges ].
	menuBuilder menu: 'Edges' submenu: 'Add' callback: [ self addEdges ].
	menuBuilder menu: 'Events' submenu: 'Orthogonal Shapes' callback: [ self orthogonalShapes ].
	menuBuilder menu: 'Events' submenu: 'Flexible Result Shapes' callback: [ self flexibleResultShapes ].
	menuBuilder menu: 'Color' submenu: 'Same queries and items in view' callback: [ self colorSameQueriesAndItemsInView ].
	menuBuilder menu: 'Color' submenu: 'Most often queries and items in view' callback: [ self colorMostOftenQueriesAndItemsInView ].
	menuBuilder menu: 'Color' submenu: 'Same queries and items in computer' callback: [ self colorSameQueriesAndItemsInComputer ].
	menuBuilder menu: 'Color' submenu: 'Most often queries and items in computer' callback: [ self colorMostOftenQueriesAndItemsInComputer ].
! !

!GTAMenuBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 14:31'!
timelineBuilder: aGTATimelineBuilder 
	timelineBuilder := aGTATimelineBuilder! !

Object subclass: #GTAMenuTimelineBuilder
	instanceVariableNames: 'timelineBuilder menuBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTAMenuTimelineBuilder methodsFor: 'building' stamp: 'JurajKubelka 5/18/2015 15:23'!
build
	self renderIn: timelineBuilder view.! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/19/2015 14:22'!
divingUsage
	self numberOfOccurrences: #divesIn inform: 'No dives-in.'
! !

!GTAMenuTimelineBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/18/2015 15:23'!
initialize
	super initialize.
	menuBuilder := RTMenuBuilder new.! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/19/2015 14:18'!
keywordUsage
	self numberOfOccurrences: #specialKeywords inform: 'No keywords.'
! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/20/2015 16:30'!
numberOfOccurrences: aSymbol inform: aNoOccurrencesString
	| elements keywords normalizer maxKeywords |
	elements := timelineBuilder elements.
	keywords := elements collect: [ :e | e -> (e model perform: aSymbol) size ].
	maxKeywords := keywords max: [ :assoc | assoc value ].
	maxKeywords = 0 ifTrue: [ 
		self inform: aNoOccurrencesString.
		^ self ].
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: (0 to: maxKeywords).
	elements do: [ :element | | elementKeywords |
		elementKeywords := keywords detect: [ :assoc | assoc key == element ].
		element trachelShape 
			color: (normalizer rtValue: elementKeywords value);
			strokePaint: (Color black alpha: 0.4) ].
	timelineBuilder view signalUpdate! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/26/2015 14:15'!
numberOfSessions
	self numberOfOccurrences: #yourself inform: 'There is not any session.'
! !

!GTAMenuTimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 5/26/2015 14:13'!
renderIn: aView
	menuBuilder view: aView.
	menuBuilder menu: 'Feature usage' submenu: 'Sessions' callback: [ self numberOfSessions ].
	menuBuilder menu: 'Feature usage' submenu: 'Keyword' callback: [ self keywordUsage ].
	menuBuilder menu: 'Feature usage' submenu: 'Diving' callback: [ self divingUsage ].
	
	menuBuilder menu: 'Data cleaning' submenu: 'Unknown items' callback: [ self unknownItems ].

	menuBuilder menu: 'Clean' callback: [ self unspeciedFeature ].
! !

!GTAMenuTimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 15:22'!
timelineBuilder
	^ timelineBuilder! !

!GTAMenuTimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 15:22'!
timelineBuilder: anObject
	timelineBuilder := anObject! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/19/2015 12:30'!
unknownItems
	self numberOfOccurrences: #unknownNames inform: 'No unknown names.'! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/20/2015 16:45'!
unspeciedFeature
	| elements normalizer  |
	elements := timelineBuilder elements.
	normalizer := RTMultiLinearColorForIdentity new 
							objects: elements;
							yourself.
	elements do: [ :element |
		element trachelShape 
			color: (normalizer rtValue: element);
			strokePaint: Color transparent ].
	timelineBuilder view signalUpdate! !

Object subclass: #GTAMultipleSelectionSendCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

GTAMultipleSelectionSendCommand class
	instanceVariableNames: 'uniqueInstance'!

GTAMultipleSelectionSendCommand class
	instanceVariableNames: 'uniqueInstance'!

!GTAMultipleSelectionSendCommand class methodsFor: 'api' stamp: 'JurajKubelka 5/11/2015 11:01'!
selection: result in: aCollection
	^ self new selection: result in: aCollection! !

!GTAMultipleSelectionSendCommand class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 19:42'!
selection: result in: aCollection as: aCollectionClass
	^ self new selection: result in: aCollection as: aCollectionClass! !

!GTAMultipleSelectionSendCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:24'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTAMultipleSelectionSendCommand methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 19:39'!
selection: result in: aCollection
	^ self selection: result in: aCollection as: aCollection species! !

!GTAMultipleSelectionSendCommand methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 12:28'!
selection: result in: aCollection as: aCollectionClass
	^ result notNil 
		ifTrue: [ 
			(result size = 1)
				ifTrue: [result anyOne] 
				ifFalse: [ aCollectionClass withAll: result ] ]
		ifFalse: [ result ]! !

Object subclass: #GTARoughDataSetBuilder
	instanceVariableNames: 'objects groups comparator gap newGroupBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughDataSetBuilder methodsFor: 'adding' stamp: 'JurajKubelka 5/11/2015 17:09'!
addToActualGroup: anObject 
	self ensureGroup.
	self groups last addLast: anObject.! !

!GTARoughDataSetBuilder methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 17:58'!
addToNewGroup: anObject
	^ self groups add: (self newGroupObject add: anObject; yourself) ! !

!GTARoughDataSetBuilder methodsFor: 'building' stamp: 'JurajKubelka 5/11/2015 18:14'!
build
	| lastObject |
	lastObject := self objects first.
	self objects doWithIndex: [ :object :index |
		index > 1 
			ifTrue: [ 
				(comparator cull: object cull: lastObject) < self gap
					ifTrue: [ self addToActualGroup: object ]
					ifFalse: [ self addToNewGroup: object ] ]
			ifFalse: [ self addToNewGroup: object ].
		lastObject := object.
	 ].
! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:50'!
comparator
	^ comparator! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:50'!
comparator: anObject
	comparator := anObject! !

!GTARoughDataSetBuilder methodsFor: 'private' stamp: 'JurajKubelka 5/14/2015 17:57'!
ensureGroup
	self groups ifEmpty: [ :aGroup | aGroup add: self newGroupObject ]! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 18:14'!
gap
	^ gap! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 18:14'!
gap: anInteger 
	gap := anInteger! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
groupClass: aClass
	self newGroupBlock: [ aClass new ]! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:55'!
groups
	^ groups ifNil: [ groups := GTAGroups new ]! !

!GTARoughDataSetBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/14/2015 17:58'!
initialize
	super initialize.
	comparator := [ :actualObject :previousObject | actualObject - previousObject ].
	newGroupBlock := [ GTAGroup new ].! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupBlock
	^ newGroupBlock! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupBlock: aBlockClosure 
	newGroupBlock := aBlockClosure! !

!GTARoughDataSetBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupObject
	^ self newGroupBlock value! !

!GTARoughDataSetBuilder methodsFor: 'helpers' stamp: 'JurajKubelka 5/11/2015 17:13'!
numberOfGroups
	^ self groups size ! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:07'!
objects
	^ objects! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:55'!
objects: aCollection 
	objects := aCollection.
	groups := nil.! !

!GTARoughDataSetBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/12/2015 09:51'!
setSessionComparator
	self comparator: [ :actualObject :previousObject | actualObject start - previousObject end ]! !

Object subclass: #GTASessionExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session1
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveInCategoryEvent new;
				add: GTSpotterRecorderContextChangedEvent new;
				add: GTSpotterRecorderSelectedCandidateChangedEvent new;
				add: GTSpotterRecorderCategorySelectedEvent new;
				add: GTSpotterRecorderDiveOutEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session2
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session3
	"Miss-steps"
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderSearchFinishedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session4
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new; 
		add: GTSpotterRecorderShowPreviewEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderSearchFinishedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderActOnEvent new; 
		yourself! !

Object subclass: #GTATool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTATool class
	instanceVariableNames: 'semaphore process'!

GTATool class
	instanceVariableNames: 'semaphore process'!

!GTATool class methodsFor: 'private' stamp: 'JurajKubelka 5/13/2015 11:58'!
checkProcess
	process isComplete ifTrue: [ semaphore signal ].
! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:15'!
defaultDownloadDirectory
	^ FileSystem disk workingDirectory! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:18'!
defaultDownloadFilename
	^ self defaultDownloadDirectory / 'gt-events.tar.gz'! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:42'!
defaultEventsDirectory
	^ self defaultDownloadDirectory / 'gt' / 'events'! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:14'!
defaultUrl
	^ 'http://gc.dcc.uchile.cl:8080/gt/events/data'! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:17'!
download
	"self download"
 	UIManager default informUserDuring: [ :bar |
		bar label: 'Download Spotter Event Data...'.
		[ ZnClient new
			url: self defaultUrl;
			downloadTo: self defaultDownloadFilename ]
		on: HTTPProgress 
		do: [ :progress |
			progress isEmpty ifFalse: [ bar current: progress percentage ].
			progress resume ] 
	]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:40'!
ensureDownloadedData
	self defaultDownloadFilename exists ifFalse: [ self download ]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:41'!
ensureExctractedData
	self defaultEventsDirectory exists ifFalse: [ self extract ]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:39'!
ensureLocalDirectory
	self 
		ensureDownloadedData;
		ensureExctractedData! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:58'!
extract
	semaphore := Semaphore new.
	process := ExternalUnixOSProcess 
		forkAndExec: '/usr/bin/tar' 
		arguments: (Array with: 'xzf' with: self defaultDownloadFilename fullName)
		environment: nil 
		descriptors: nil 
		workingDir: self defaultDownloadDirectory fullName.
	process addDependent: self.
	self checkProcess.
	semaphore wait.
	process := nil.
	semaphore := nil.! !

!GTATool class methodsFor: 'updating' stamp: 'JurajKubelka 5/13/2015 11:57'!
update: aParameter
	aParameter = #runState ifTrue: [ self checkProcess ]! !

Object subclass: #GTSpotterAnalysisCommand
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

GTSpotterAnalysisCommand subclass: #GTADelayedExitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTADelayedExitCommand methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/27/2015 16:27'!
clean
	self session removeHasDelayedExit! !

!GTADelayedExitCommand methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/27/2015 16:41'!
execute
	| close nextToLast |
	self session last isCloseSpotter ifFalse: [ ^ self ].
	close := self session last dateAndTimeWithFixedTimeZone.
	nextToLast := self session nextToLast dateAndTimeWithFixedTimeZone.
	close - nextToLast < 1 minute ifTrue: [ ^ self ].
	self session setHasDelayedExit! !

GTSpotterAnalysisCommand subclass: #GTADirectSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTADirectSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 5/27/2015 16:04'!
analysisOrder
	^ GTAEmptySessionCommand analysisOrder + 1! !

!GTADirectSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 16:07'!
clean
	self session removeIsDirectSession.! !

!GTADirectSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 16:32'!
execute
	self session hasDelayedExit ifTrue: [ ^ self ].
	self session isEmptySession ifTrue: [ ^ self ].
	self session numberOfDivesIn = 0 ifFalse: [ ^ self ].
	self session setDirectSession.! !

GTSpotterAnalysisCommand subclass: #GTAEmptySessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAEmptySessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 5/27/2015 16:27'!
analysisOrder
	^ GTADelayedExitCommand analysisOrder + 1! !

!GTAEmptySessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 10:40'!
clean
	self session removeIsEmptySession! !

!GTAEmptySessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 16:32'!
execute
	| displayed |
	self session hasDelayedExit ifTrue: [ ^ self ].
	self session ifEmpty: [ ^ self setEmpty ].
	self session last isActOn ifTrue: [ ^ self ].
	displayed := (self session select: #isForTimelineView).
	displayed size > 3 ifTrue: [ ^ self ].
	self setEmpty.! !

!GTAEmptySessionCommand methodsFor: 'api' stamp: 'JurajKubelka 5/27/2015 10:47'!
setEmpty
	self session setIsEmptySession! !

GTSpotterAnalysisCommand subclass: #GTAFirstLevelDiveInSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAFirstLevelDiveInSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 5/27/2015 16:55'!
analysisOrder
	^ GTADirectSessionCommand analysisOrder + 1! !

!GTAFirstLevelDiveInSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 17:01'!
clean
	self session removeIsFirstLevelDiveInSession! !

!GTAFirstLevelDiveInSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 17:39'!
execute
	self session hasDelayedExit ifTrue: [ ^ self ].
	self session isEmptySession ifTrue: [ ^ self ].
	self session isDirectSession ifTrue: [ ^ self ].
	self session deepestDiveIn = 2 ifFalse: [ ^ self ].
	self session setIsFirstLevelDiveInSession.! !

GTSpotterAnalysisCommand subclass: #GTAPreviousSelectionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAPreviousSelectionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 12:25'!
analysisOrder
	^ (GTSpotterElementWithCategoryCommand analysisOrder max:
			GTSpotterDiveInLevelCommand analysisOrder) + 1! !

!GTAPreviousSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 12:40'!
clean
	self session do: [ :each | 
		each isUserSelectionClass ifTrue: [ each removePreviousSelection ] ]! !

!GTAPreviousSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 12:34'!
execute
	| selections diveInLevels |
	selections := self session select: #isUserSelectionClass.
	selections size < 2 ifTrue: [ ^ self ].
	diveInLevels := Dictionary new.
	selections withIndexDo: [ :selection :index | | lastSelection |
		lastSelection := diveInLevels at: selection diveInLevel ifAbsent: [ nil ].
		lastSelection ifNotNil: [ selection previousSelection: lastSelection ].
		diveInLevels at: selection diveInLevel put: selection ]! !

!GTSpotterAnalysisCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:13'!
analysisOrder
	^ 100! !

!GTSpotterAnalysisCommand class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: aGTSpotterSession 
	^ self new context: aGTSpotterSession; yourself! !

!GTSpotterAnalysisCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:12'!
clean
	self subclassResponsibility! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context
	^ context! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: anObject
	context := anObject! !

!GTSpotterAnalysisCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 11:31'!
execute
	self subclassResponsibility! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:32'!
session
	^ self context session! !

GTSpotterAnalysisCommand subclass: #GTSpotterDiveInLevelCommand
	instanceVariableNames: 'dives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterDiveInLevelCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 1! !

!GTSpotterDiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:23'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeDiveInEvent;
			removeSameLevelEvents ]! !

!GTSpotterDiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 12:00'!
execute
	self session do: [ :eachEvent |
		eachEvent isDiveIn ifTrue: [ self updateDiveIn: eachEvent ].
		eachEvent isDiveOut ifTrue: [ self updateDiveOut: eachEvent ].
		eachEvent isDive ifFalse: [ self updateEvent: eachEvent ].
	]! !

!GTSpotterDiveInLevelCommand methodsFor: 'initialization' stamp: 'JurajKubelka 3/31/2015 12:06'!
initialize
	super initialize.
	dives := OrderedCollection new! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:58'!
updateDiveIn: anEvent
	self updateEvent: anEvent.
	dives add: anEvent.
! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:11'!
updateDiveOut: anEvent
	dives ifEmpty: [ ^ anEvent markAsStrange: 'Dive-Out before Dive-In.' ].
	self updateEvent: anEvent.
	dives removeLast ! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 12:11'!
updateEvent: anEvent
	dives ifEmpty: [ ^ self ].
	anEvent diveInEvent: dives last.
	dives last addSameLevelEvent: anEvent.
! !

GTSpotterAnalysisCommand subclass: #GTSpotterElementWithCategoryCommand
	instanceVariableNames: 'selection category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterElementWithCategoryCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:10'!
analysisOrder
	^ 1! !

!GTSpotterElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:25'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeStrange;
			removeSelectedCategoryEvent;
			removeSelectedElementEvents ]! !

!GTSpotterElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 14:10'!
execute
	self session do: [ :eachEvent |
		eachEvent isUserSelectionClass ifTrue: [ self updateSelection: eachEvent ].
		eachEvent isCategorySelection ifTrue: [ self updateCategory: eachEvent ].
	].
	self updateSelection: nil.! !

!GTSpotterElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:44'!
updateCategory: anEvent
	selection ifNil: [ ^ anEvent markAsStrange: 'Category selection before element selection.' ].
	selection selectedCategoryEvent: anEvent.
	anEvent selectedElementEvent: selection.
	selection := nil.
	category := anEvent.! !

!GTSpotterElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:43'!
updateSelection: anEvent
	selection ifNotNil: [ 
		category 
			ifNil: [ selection markAsStrange: 'There is no category selection before.' ]
			ifNotNil: [ :aCategory | 
				selection selectedCategoryEvent: aCategory.
				aCategory selectedElementEvent: selection.  ]
		 ].
	selection := anEvent.! !

GTSpotterAnalysisCommand subclass: #GTSpotterLinkToSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterLinkToSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:09'!
analysisOrder
	^ 1! !

!GTSpotterLinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
clean
	self session do: [ :eachEvent |
		eachEvent removeSession ]! !

!GTSpotterLinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
execute
	self session do: [ :eachEvent |
		eachEvent session: self session ]! !

GTSpotterAnalysisCommand subclass: #GTSpotterMissStepsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterMissStepsCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 50! !

!GTSpotterMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:26'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeIsMissStep ]! !

!GTSpotterMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:53'!
execute
	| divesIn |
	divesIn := self session select: #isDiveIn.
	divesIn withIndexDo: [ :aDiveIn :index |
		(index + 1) <= divesIn size ifTrue: [ 
			((aDiveIn hasQuery or: [ aDiveIn hasDiveIn ]) not and:
				[ aDiveIn duration < 3 seconds ]) ifTrue: [ 
				aDiveIn setMissStep.
			]
		]
	]! !

GTSpotterAnalysisCommand subclass: #GTSpotterSameTimestampCommand
	instanceVariableNames: 'timestamp events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSameTimestampCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:08'!
analysisOrder
	^ GTSpotterLinkToSessionCommand analysisOrder + 1! !

!GTSpotterSameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:09'!
addEvent: aSpotterEvent 
	events ifNil: [ events := OrderedCollection new ].
	events addLast: aSpotterEvent! !

!GTSpotterSameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 19:25'!
clean
	self session do: [ :event | event removeSameTimeEvents ]! !

!GTSpotterSameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:27'!
consolidateEvents: aDateAndTime 
	events ifNil: [ ^ self ].
	events withIndexDo: [ :event :index |
		event sameTimeEvents: events index: index nextDateAndTime: aDateAndTime ].
	events := nil.! !

!GTSpotterSameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/11/2015 22:50'!
execute
	| eventTimestamp |
	self session do: [ :eachEvent | 
		eventTimestamp := eachEvent dateAndTimeWithFixedTimeZone.
		timestamp 
			ifNil: [ 
				timestamp := eventTimestamp.
				self addEvent: eachEvent. ]
			ifNotNil: [ 
				timestamp = eventTimestamp 
					ifTrue: [ self addEvent: eachEvent ] 
					ifFalse: [ self consolidateEvents: eventTimestamp.
						timestamp := eventTimestamp.
						self addEvent: eachEvent. ] ]
		 ].
	self consolidateEvents: eventTimestamp! !

Object subclass: #GTSpotterEventIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:36'!
actOnIcon
	^ Smalltalk ui icons glamorousPlay! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:43'!
contextChangedIcon
	^ Smalltalk ui icons glamorousEdit  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:20'!
diveInCategoryIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInCategoryMissStepIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon
		deepCopy 
			mapColor: (Color r: 0.581 g: 0.581 b: 0.581 alpha: 1.0)
			to: Color red! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
diveInElementIcon
	^ Smalltalk ui icons glamorousDiveRightIcon  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInElementMissStepIcon
	^ Smalltalk ui icons glamorousDiveRightIcon 
			deepCopy mapColor: Color black to: Color red! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:41'!
diveOutIcon
	^ Smalltalk ui icons glamorousLeft  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:46'!
exitIcon
	^ Smalltalk ui icons glamorousClose  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
hidePreviewIcon
	^ Smalltalk ui icons glamorousZoomOut! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
noIcon
	^ Smalltalk ui icons protocolNoneIcon! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:45'!
selectedCandidateChangedIcon
	^ Smalltalk ui icons glamorousGrayCircle  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
showPreviewIcon
	^ Smalltalk ui icons glamorousZoomIn! !

Object subclass: #GTSpotterPrintDateAndTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterPrintDateAndTime class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 13:48'!
yyyyMmDdAndHhMmSs: aDateAndTimeOrZero
	"Returns YYYY-MM-DD, HH:MM:SS in UTC time."
	aDateAndTimeOrZero = 0 ifTrue: [ ^ 'unknown' ].
	^ String streamContents: [ :aStream |
		aDateAndTimeOrZero asUTC printYMDOn: aStream.
		aStream nextPutAll: ', '.
		aDateAndTimeOrZero asUTC printHMSOn: aStream ] ! !

Object subclass: #GTSpotterSessionAnalysis
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 3/31/2015 11:50'!
executeOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) execute! !

!GTSpotterSessionAnalysis class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: aGTSpotterSession 
	^ self new session: aGTSpotterSession; yourself! !

!GTSpotterSessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) clean; execute! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/13/2015 14:52'!
analyze: aCollection 
	self 
		session: aCollection;
		clean; 
		execute! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:15'!
clean
	(GTSpotterAnalysisCommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command clean ].
	^ self session! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:31'!
execute
	(GTSpotterAnalysisCommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command execute ].
	^ self session! !

!GTSpotterSessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session
	^ session! !

!GTSpotterSessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: anObject
	session := anObject! !

Object subclass: #GTSpotterSessionsBuilder
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSessionsBuilder commentStamp: 'JurajKubelka 3/31/2015 11:24' prior: 0!
I'm a session builder, I receive collected announcements and split events per computer and per session. Session starts with opening Spotter and finishs on closing Spotter.!

!GTSpotterSessionsBuilder class methodsFor: 'api' stamp: 'JurajKubelka 3/30/2015 15:48'!
fromEvents: aCollection 
	^ self new events: aCollection; sessions! !

!GTSpotterSessionsBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:48'!
events: aCollection 
	events := aCollection! !

!GTSpotterSessionsBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
sessions 
	| borders pairs openOrExit previousAssociation computer |
	events ifEmpty: [ ^ GTAComputer new ].
	borders := events withIndexCollect: [ :event :index |
		event isOpenOrCloseSpotter 
				ifTrue: [ index -> event ]
				ifFalse: [ nil ]
		 ].
	borders := borders select: [ :each | each notNil ].
	pairs := OrderedCollection new.
	openOrExit := #open.
	previousAssociation := borders first.
	borders do: [ :eachAssociation |
		(openOrExit = #open) 
			ifTrue: [ 
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs addLast: eachAssociation. 
					openOrExit := #exit ] ]
			ifFalse: [ 
				eachAssociation value isCloseSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> eachAssociation. 
					openOrExit := #open ].
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> previousAssociation.
					pairs addLast: eachAssociation.
					openOrExit := #exit ] ].
		previousAssociation := eachAssociation.
	].
	openOrExit = #exit ifTrue: [ pairs removeLast ].
	computer := pairs collect: [ :eachPair | | open exit |
		open := eachPair key.
		exit := eachPair value.
		GTASession withAll: (events copyFrom: open key to: exit key).
		 ] as: GTAComputer.
	computer do: [ :eachSession | eachSession computer: computer ].
	^ computer! !

Object subclass: #GTSpotterTimeline
	instanceVariableNames: 'data view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterTimeline class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 18:34'!
viewOn: objects
	^ self new
			data: objects;
			build;
			view! !

!GTSpotterTimeline methodsFor: 'building' stamp: 'JurajKubelka 4/14/2015 11:17'!
build
	| shape elements visibleData levels |
	view := RTView new.
	view @ RTDraggableView.
	shape := RTBitmap new.
	shape form: #analysisIcon.
	visibleData := self visibleData.
	levels := visibleData deepestDiveIn.
	elements := shape elementsOn: visibleData.
	elements @ RTDraggable @ (RTPopup text: #asEventAnalysisString).
	view addAll: elements.
	"RTGridLayout on: elements."
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: 500;
		normalizeY: [ :eachEvent | self yFor: eachEvent ] min: 0 max: (levels * 4).
! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data
	^ data! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data: anObject
	data := anObject! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view
	^ view! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view: anObject
	view := anObject! !

!GTSpotterTimeline methodsFor: 'enumerating' stamp: 'JurajKubelka 4/9/2015 19:52'!
visibleData
	^ self data select: #isForTimelineView! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:14'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 20:15'!
yFor: aSpotterEvent
	^ aSpotterEvent diveInLevel! !

!Object methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 10:37'!
isSpotterEvent
	^ false! !
